<FLEXDOCXYZ_TEMPLATE VER='1.23'>
CREATED='2004-06-21 01:50:00'
LAST_UPDATE='2021-11-28 13:49:08'
DESIGNER_TOOL='FlexDoc.XYZ SDK 1.x'
DESIGNER_LICENSE_TYPE='Filigris Works Team'
APP_ID='flexdoc-xml-xsddoc2'
APP_NAME='FlexDoc/XML XSDDoc'
APP_VER='2.9.5'
APP_AUTHOR='Copyright © 2005-2021 Filigris Works, Leonid Rudy Softwareprodukte. All rights reserved.'
TEMPLATE_TYPE='DocumentTemplate'
DSM_TYPE_ID='xsddoc'
ROOT_ET='xs:%localElement'
DESCR='Prints extension for the local element name which is allows it to be distinguished it from others.

IMPORTANT: The root element passed to this template must be either globaly documented directly (not via a unifier) or not globally documented at all.'
<TEMPLATE_PARAMS>
	PARAM={
		param.name='$linkDestKeys';
		param.type='string';
		param.list='true';
		param.defaultValue.expr='Array ("detail", "xml-source-location")';
	}
	PARAM={
		param.name='$targetFrame';
		param.type='string';
	}
	PARAM={
		param.name='$mainXSD';
		param.type='GOMElement';
		param.defaultValue.expr='findElementByKey ("main-xsds", getXMLDocument().id)';
	}
	PARAM={
		param.name='$xmlContexts';
		param.description='Specifies an array of one or several alternative elements that determine the XML document context (i.e. the position on the XML document\'s tree) against which the namespace prefix/URI binding will be resolved.';
		param.type='GOMElement';
		param.list='true';
		param.defaultValue.expr='Array (contextElement)';
	}
	PARAM={
		param.name='gen.doc';
		param.title='Generate Details';
		param.title.style.bold='true';
		param.group='true';
	}
	PARAM={
		param.name='gen.doc.element.local.unifyByType';
		param.title='Unify local elements by type';
		param.type='boolean';
	}
	PARAM={
		param.name='show';
		param.title='Show';
		param.title.style.bold='true';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='show.linkTitle';
		param.title='Link Titles (Tooltips)';
		param.type='boolean';
	}
</TEMPLATE_PARAMS>
<STYLES>
	CHAR_STYLE={
		style.name='Default Paragraph Font';
		style.id='cs1';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Hyperlink';
		style.id='cs2';
		text.decor.underline='true';
		text.color.foreground='#0000FF';
	}
	PAR_STYLE={
		style.name='Normal';
		style.id='ps1';
		style.default='true';
	}
</STYLES>
FMT={
	doc.lengthUnits='pt';
}
<ROOT>
	<ELEMENT_ITER>
		DESCR='when the element is included in the content model of only one other element,
its extension may be represented as: "in <parent> ... ";

see: Processing | Iteration Scope | Expression for Element Enumeration'
		BREAK_PARENT_BLOCK='when-output'
		TARGET_ET='xs:%element'
		SCOPE='custom'
		ELEMENT_ENUM_EXPR='/* Collect the entire single-parent chain for the initial local element, i.e.:
this local element -> its only parent -> its only parent -> etc.

That chain may be actually repeating (according to all involved content models).
That is, it will include the initial local element itself. 
However, the returned enumeration stops when the repeating is found. */

repeating = false;
 
elements = findElementsByLRules (Array (
  LocationRule (\'*
    [
      contextElement.id == rootElement.id
      ||
      instanceOf("xs:%localElement") &&
      {
        // test if the name of this local element is not unique

        schema = findAncestor ("xs:schema");

        qName = QName (
          ((hasAttr("form") ? getAttrValue("form") :
             schema.getAttrValue ("elementFormDefault")) == "qualified" 
               ? schema.getServiceAttr("targetNamespace").toString() : ""),
          getAttrStringValue("name")
        );

        mainXSDFilter = BooleanQuery (checkElementByKey (
                          "main-xsds",
                          getXMLDocument().id,
                          getElementParam("$mainXSD")
                        ));

        countElementsByKey ("global-elements", qName, mainXSDFilter) +
        countElementsByKey ("local-elements", qName, mainXSDFilter) > 1
      }
    ] -> {
      countElementsByKey ("containing-elements", contextElement.id) == 1
        ? findElementsByKey ("containing-elements", contextElement.id) : null
    }::*[
      contextElement.id == rootElement.id ? { repeating = true; false } : true
    ]\',
    true
  )
));

elements.hasNext() && repeating ?
{
  /* When the repeating is found, look who is the parent of the initial local element.
   When the parent is another local element with a global type, its declaration cannot contain
   the declaration of the initial local element. In that case, it is better to generate a different
   type of extension. The returned \'null\' will cause the processing of this section to break and
   to skip to the next section. */

  el = toElement (elements.next());
  el.instanceOf ("xs:%localElement") && el.getAttrValue("type") != "" ? 
    return null;

  elements = Enum (el, elements);
};

/* Otherwise, print the whole single-parent chain like: 
"in <parent> in <parent> in <parent> ... "
The last element in the chain may be a global one or, when it is local,
it requires either no extension or the extension of a different type */

elements'
		FMT={
			sec.outputStyle='text-par';
			txtfl.separator.type='space';
		}
		<HEADER>
			<AREA_SEC>
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<TEXT_CTRL>
								TEXT=' ('
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</HEADER>
		<BODY>
			<AREA_SEC>
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<TEXT_CTRL>
								TEXT='in'
							</TEXT_CTRL>
							<SS_CALL_CTRL>
								SS_NAME='Component Name'
							</SS_CALL_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<FOLDER>
				DESCR='print the extension of the last local element in the chain (if required)'
				COND='iterator.isLastItem
&&
instanceOf("xs:%localElement") &&
{
  // test if the name of this local element is not unique

  schema = findAncestor ("xs:schema");

  qName = QName (
    ((hasAttr("form") ? getAttrValue("form") :
       schema.getAttrValue ("elementFormDefault")) == "qualified" 
         ? schema.getServiceAttr("targetNamespace").toString() : ""),
    getAttrStringValue("name")
  );

  mainXSDFilter = BooleanQuery (checkElementByKey (
                    "main-xsds",
                    getXMLDocument().id,
                    getElementParam("$mainXSD")
                  ));

  countElementsByKey ("global-elements", qName, mainXSDFilter) +
  countElementsByKey ("local-elements", qName, mainXSDFilter) > 1
}'
				<BODY>
					<AREA_SEC>
						DESCR='otherwise, if the following conditions are satisfied:

- the element has \'type\' attribute
- the unification by type is enabled 
- the element is documented globally'
						COND='getAttrValue("type") != ""
&&
getBooleanParam("gen.doc.element.local.unifyByType")
&&
checkElementsByKey (
  "globally-documented-local-elements",
  contextElement.id
)'
						BREAK_PARENT_BLOCK='when-executed'
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<TEXT_CTRL>
										TEXT=':'
									</TEXT_CTRL>
									<SS_CALL_CTRL>
										SS_NAME='Type By QName'
										PARAMS_EXPR='Array (getAttrQNameValue("type"))'
										FMT={
											txtfl.separator.type='text';
											txtfl.separator.text=', ';
										}
									</SS_CALL_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
					<AREA_SEC>
						DESCR='otherwise, derive the element name extension from its definition location'
						CONTEXT_ELEMENT_EXPR='findAncestor("xs:complexType|xs:group")'
						MATCHING_ETS={'xs:complexType';'xs:group'}
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<TEXT_CTRL>
										TEXT='defined in'
									</TEXT_CTRL>
									<SS_CALL_CTRL>
										SS_NAME='Component Name'
									</SS_CALL_CTRL>
									<SEPARATOR>
									</SEPARATOR>
									<TEXT_CTRL>
										MATCHING_ET='xs:complexType'
										TEXT='complexType'
									</TEXT_CTRL>
									<TEXT_CTRL>
										MATCHING_ET='xs:group'
										TEXT='group'
									</TEXT_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
			</FOLDER>
		</BODY>
		<FOOTER>
			<AREA_SEC>
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<TEXT_CTRL>
								TEXT=')'
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</FOOTER>
	</ELEMENT_ITER>
	<AREA_SEC>
		DESCR='otherwise, if the following conditions are satisfied:
- the element has \'type\' attribute
- the unification by type is enabled 
- the element is documented globally'
		COND='getAttrValue("type") != ""
&&
getBooleanParam("gen.doc.element.local.unifyByType")
&&
checkElementsByKey (
  "globally-documented-local-elements",
  contextElement.id
)'
		BREAK_PARENT_BLOCK='when-executed'
		FMT={
			sec.outputStyle='text-par';
			txtfl.separator.type='none';
		}
		<AREA>
			<CTRL_GROUP>
				<CTRLS>
					<TEXT_CTRL>
						TEXT=' (type '
					</TEXT_CTRL>
					<SS_CALL_CTRL>
						SS_NAME='Type By QName'
						PARAMS_EXPR='Array (getAttrQNameValue("type"))'
						FMT={
							txtfl.separator.type='text';
							txtfl.separator.text=', ';
						}
					</SS_CALL_CTRL>
					<TEXT_CTRL>
						TEXT=')'
					</TEXT_CTRL>
				</CTRLS>
			</CTRL_GROUP>
		</AREA>
	</AREA_SEC>
	<AREA_SEC>
		DESCR='Otherwise, derive the element name extension from its definition location.

Since this local element is not included in the content model of only one other element, it must be defined within a global complex type or element group. Indeed, a local element can be defined only in three types of locations:

- a global complex type
- a global element group
- an anonymous complex type within another element component.

The last possibility is excluded here because in that case the given local element would be included in the content model of the only other element -- the one in which it is defined.'
		CONTEXT_ELEMENT_EXPR='findAncestor("xs:complexType|xs:group")'
		MATCHING_ETS={'xs:complexType';'xs:group'}
		FMT={
			sec.outputStyle='text-par';
			txtfl.separator.type='none';
		}
		<AREA>
			<CTRL_GROUP>
				<CTRLS>
					<TEXT_CTRL>
						TEXT=' (defined in '
					</TEXT_CTRL>
					<SS_CALL_CTRL>
						SS_NAME='Component Name'
					</SS_CALL_CTRL>
					<SEPARATOR>
					</SEPARATOR>
					<TEXT_CTRL>
						MATCHING_ET='xs:complexType'
						TEXT='complexType'
					</TEXT_CTRL>
					<TEXT_CTRL>
						MATCHING_ET='xs:group'
						TEXT='group'
					</TEXT_CTRL>
					<TEXT_CTRL>
						TEXT=')'
					</TEXT_CTRL>
				</CTRLS>
			</CTRL_GROUP>
		</AREA>
	</AREA_SEC>
</ROOT>
<STOCK_SECTIONS>
	<TEMPLATE_CALL>
		SS_NAME='Component Name'
		DESCR='prints the qualified name of any global schema component and local element (passed as the stock-section context element)'
		TEMPLATE_FILE='../component/componentName.tpl'
		PASSED_PARAMS={
			'show.elementNameExt','"never"';
		}
		FMT={
			sec.outputStyle='text-par';
		}
	</TEMPLATE_CALL>
	<TEMPLATE_CALL>
		SS_NAME='Link Title'
		TEMPLATE_FILE='../component/componentLinkTitle.tpl'
	</TEMPLATE_CALL>
	<FOLDER>
		SS_NAME='Type By QName'
		DESCR='param: QName of the type'
		<BODY>
			<AREA_SEC>
				DESCR='if type can be resolved'
				CONTEXT_ELEMENT_EXPR='findElementByKey (
  "types",
  stockSection.param.toQName(),
  BooleanQuery (
    checkElementByKey (
      "main-xsds",
      getXMLDocument().id,
      getElementParam("$mainXSD")
    )
  )
)'
				MATCHING_ETS={'xs:complexType';'xs:simpleType'}
				BREAK_PARENT_BLOCK='when-executed'
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<DATA_CTRL>
								COND='! getAttrBooleanValue ("abstract")'
								EXPR='toXMLName (
  stockSection.param.toQName(),
  getArrayParam("$xmlContexts")
)'
								<DOC_HLINK>
									TITLE_EXPR='getBooleanParam("show.linkTitle") ? callStockSection("Link Title")'
									TARGET_FRAME_EXPR='getStringParam("$targetFrame")'
									HKEYS={
										'contextElement.id';
										'getArrayParam("$linkDestKeys")';
									}
								</DOC_HLINK>
							</DATA_CTRL>
							<DATA_CTRL>
								COND='getAttrBooleanValue ("abstract")'
								EXPR='toXMLName (
  stockSection.param.toQName(),
  getArrayParam("$xmlContexts")
)'
								FMT={
									text.font.style.italic='true';
								}
								<DOC_HLINK>
									TITLE_EXPR='getBooleanParam("show.linkTitle") ? callStockSection("Link Title")'
									TARGET_FRAME_EXPR='getStringParam("$targetFrame")'
									HKEYS={
										'contextElement.id';
										'getArrayParam("$linkDestKeys")';
									}
								</DOC_HLINK>
							</DATA_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<DATA_CTRL>
								EXPR='toXMLName (
  stockSection.param.toQName(),
  getArrayParam("$xmlContexts")
)'
							</DATA_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</BODY>
	</FOLDER>
</STOCK_SECTIONS>
CHECKSUM='YWrmfvmeUz5vz34LiuULg6Bc3HBbaqUiuiIE0SvMD88'
</FLEXDOCXYZ_TEMPLATE>