<FLEXDOCXYZ_TEMPLATE VER='1.23'>
CREATED='2014-08-06 02:47:00'
LAST_UPDATE='2021-11-28 13:49:11'
DESIGNER_TOOL='FlexDoc.XYZ SDK 1.x'
DESIGNER_LICENSE_TYPE='Filigris Works Team'
APP_ID='flexdoc-xml-wsdldoc'
APP_NAME='FlexDoc/XML WSDLDoc'
APP_VER='1.2.5'
APP_AUTHOR='Copyright © 2012-2021 Filigris Works, Leonid Rudy Softwareprodukte. All rights reserved.'
TEMPLATE_TYPE='DocumentTemplate'
DSM_TYPE_ID='wsdldoc'
ROOT_ET='#DOCUMENTS'
DESCR='This template generates a single-file WSDL/XSD documentation in any of the supported output formats. It may be particularly useful when the documentation is intended for printing.

${include help/refs/single_file_doc.htm}'
INIT_EXPR='callStockSection("Init");

setXMLNameForm (
  getBooleanParam("show.nsPrefix") ? "qualified" : "unqualified"
);'
TITLE_EXPR='getStringParam("windowTitle")'
<TEMPLATE_PARAMS>
	PARAM={
		param.name='$resourceOutputDir';
		param.title='Documentation resources directory';
		param.description='This parameter is used internally. It specifies the absolute pathname of a directory where all commonly used icons are to be stored.
<p>
If this pathname is empty, all resource (icon) files used by a given document will be stored in the local \'doc-files\' directory associated with that document.';
		param.type='string';
		param.defaultValue.expr='output.docFilesDir + "/resources"';
		param.hidden='true';
	}
	PARAM={
		param.name='docTitle';
		param.title='Documentation Title';
		param.description='${include help/params/docTitle.htm}';
		param.type='text';
		param.defaultValue='WSDL/XSD Documentation';
	}
	PARAM={
		param.name='windowTitle';
		param.title='Window Title';
		param.description='${include help/params/windowTitle.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
	}
	PARAM={
		param.name='gen';
		param.title='Generate Details';
		param.title.style.bold='true';
		param.description='${include help/params/gen/gen.htm}';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='gen.for';
		param.title='For';
		param.title.style.italic='true';
		param.description='${include help/params/gen/for/gen.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='gen.for.namespaces';
		param.title='Namespaces';
		param.title.style.italic='true';
		param.description='${include help/params/gen/for/gen.for.namespaces.htm}';
		param.group='true';
	}
	PARAM={
		param.name='gen.for.namespaces.include';
		param.title='Include';
		param.title.style.italic='true';
		param.description='${include help/params/gen/for/gen.for.namespaces.include.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.list='true';
		param.list.noEmptyList='true';
	}
	PARAM={
		param.name='gen.for.namespaces.exclude';
		param.title='Exclude';
		param.title.style.italic='true';
		param.description='${include help/params/gen/for/gen.for.namespaces.exclude.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.list='true';
		param.list.noEmptyList='true';
	}
	PARAM={
		param.name='gen.for.files';
		param.title='WSDL/XSD Files';
		param.title.style.italic='true';
		param.description='${include help/params/gen/for/gen.for.files.htm}';
		param.group='true';
	}
	PARAM={
		param.name='gen.for.files.initial';
		param.title='Initial';
		param.title.style.italic='true';
		param.description='${include help/params/gen/for/gen.for.files.initial.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.for.files.referenced';
		param.title='Referenced';
		param.title.style.italic='true';
		param.description='${include help/params/gen/for/gen.for.files.referenced.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.for.files.referenced.wsdl';
		param.title='WSDL';
		param.title.style.italic='true';
		param.description='${include help/params/gen/for/gen.for.files.referenced.wsdl.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.for.files.referenced.xsd';
		param.title='XSD';
		param.title.style.italic='true';
		param.description='${include help/params/gen/for/gen.for.files.referenced.xsd.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.for.files.include';
		param.title='Include';
		param.title.style.italic='true';
		param.description='${include help/params/gen/for/gen.for.files.include.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='gen.for.files.exclude';
		param.title='Exclude';
		param.title.style.italic='true';
		param.description='${include help/params/gen/for/gen.for.files.exclude.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='gen.for.embeddedSchemas';
		param.title='Embedded Schemas';
		param.title.style.italic='true';
		param.description='${include help/params/gen/for/gen.for.embeddedSchemas.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/gen/sorting/gen.sorting.htm}';
		param.group='true';
	}
	PARAM={
		param.name='gen.sorting.namespaces';
		param.title='Namespaces';
		param.title.style.italic='true';
		param.description='${include help/params/gen/sorting/gen.sorting.namespaces.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.sorting.wsdl.files';
		param.title='WSDL Files';
		param.title.style.italic='true';
		param.description='${include help/params/gen/sorting/gen.sorting.wsdl.files.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.sorting.xsd.schemas';
		param.title='Schemas';
		param.title.style.italic='true';
		param.description='${include help/params/gen/sorting/gen.sorting.xsd.schemas.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.sorting.wsdl.defs';
		param.title='WSDL Definitions';
		param.title.style.italic='true';
		param.description='${include help/params/gen/sorting/gen.sorting.wsdl.defs.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.sorting.xsd.comps';
		param.title='XSD Components';
		param.title.style.italic='true';
		param.description='${include help/params/gen/sorting/gen.sorting.xsd.comps.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.grouping';
		param.title='Grouping';
		param.title.style.italic='true';
		param.description='${include help/params/gen/grouping/gen.grouping.htm}';
		param.group='true';
	}
	PARAM={
		param.name='gen.grouping.comps';
		param.title='Components';
		param.title.style.italic='true';
		param.description='${include help/params/gen/grouping/gen.grouping.comps.htm}';
		param.type='enum';
		param.enum.values='namespace;file;allcomps';
		param.enum.displayValues='by namespaces;by files;all together';
	}
	PARAM={
		param.name='gen.toc';
		param.title='Table Of Contents';
		param.description='${include help/params/gen/gen.toc.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.overview';
		param.title='Overview Summary';
		param.description='${include help/params/gen/gen.overview.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.allcomps';
		param.title='All Component Summary';
		param.description='${include help/params/gen/gen.allcomps.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='gen.namespace';
		param.title='Namespace Overviews';
		param.description='${include help/params/gen/gen.namespace.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.wsdl.file';
		param.title='WSDL Files';
		param.title.style.bold='true';
		param.description='${include help/params/gen/wsdl/gen.wsdl.file.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.wsdl.file.overview';
		param.title='Overview';
		param.description='${include help/params/gen/wsdl/gen.wsdl.file.overview.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.wsdl.file.source';
		param.title='XML Source';
		param.description='${include help/params/gen/wsdl/gen.wsdl.file.source.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.xsd.schema';
		param.title='Schemas';
		param.title.style.bold='true';
		param.description='${include help/params/gen/xsd/gen.xsd.schema.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.xsd.schema.overview';
		param.title='Overview';
		param.description='${include help/params/gen/xsd/gen.xsd.schema.overview.htm}';
		param.type='enum';
		param.enum.values='all;xsd_files;none';
		param.enum.displayValues='all;XSD files only;none';
	}
	PARAM={
		param.name='gen.xsd.schema.source';
		param.title='XML Source';
		param.description='${include help/params/gen/xsd/gen.xsd.schema.source.htm}';
		param.type='enum';
		param.enum.values='all;xsd_files;none';
		param.enum.displayValues='all;XSD files only;none';
		param.defaultValue='xsd_files';
	}
	PARAM={
		param.name='gen.wsdl.def';
		param.title='WSDL Definitions';
		param.title.style.bold='true';
		param.description='${include help/params/gen/wsdl/gen.wsdl.def.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.wsdl.def.service';
		param.title='Services';
		param.description='${include help/params/gen/wsdl/gen.wsdl.def.service.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.wsdl.def.service.names';
		param.title='Names';
		param.description='${include help/params/gen/wsdl/gen.wsdl.def.service.names.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='gen.wsdl.def.binding';
		param.title='Bindings';
		param.description='${include help/params/gen/wsdl/gen.wsdl.def.binding.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.wsdl.def.binding.names';
		param.title='Names';
		param.description='${include help/params/gen/wsdl/gen.wsdl.def.binding.names.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='gen.wsdl.def.portType';
		param.title='Port Types';
		param.description='${include help/params/gen/wsdl/gen.wsdl.def.portType.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.wsdl.def.portType.names';
		param.title='Names';
		param.description='${include help/params/gen/wsdl/gen.wsdl.def.portType.names.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='gen.wsdl.def.message';
		param.title='Messages';
		param.description='${include help/params/gen/wsdl/gen.wsdl.def.message.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.wsdl.def.message.names';
		param.title='Names';
		param.description='${include help/params/gen/wsdl/gen.wsdl.def.message.names.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='gen.xsd.comp';
		param.title='XSD Components';
		param.title.style.bold='true';
		param.description='${include help/params/gen/xsd/gen.xsd.comp.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.xsd.comp.element';
		param.title='Elements';
		param.description='${include help/params/gen/xsd/gen.xsd.comp.element.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.xsd.comp.element.topLevel';
		param.title='Separate Top-Level Elements';
		param.description='${include help/params/gen/xsd/gen.xsd.comp.element.topLevel.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.xsd.comp.element.topLevel.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/gen/xsd/gen.xsd.comp.element.topLevel.sorting.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.sorting.xsd.comps")';
	}
	PARAM={
		param.name='gen.xsd.comp.element.local';
		param.title='Local Elements';
		param.description='${include help/params/gen/xsd/gen.xsd.comp.element.local.htm}';
		param.group='true';
		param.group.defaultState='expanded';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='all;complexType;none';
		param.enum.displayValues='all;with complex type only;none';
	}
	PARAM={
		param.name='gen.xsd.comp.element.local.unifyByType';
		param.title='Unify By Type';
		param.title.style.italic='true';
		param.description='${include help/params/gen/xsd/gen.xsd.comp.element.local.unifyByType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.xsd.comp.element.names';
		param.title='Names';
		param.description='${include help/params/gen/xsd/gen.xsd.comp.element.names.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='gen.xsd.comp.complexType';
		param.title='Complex Types';
		param.description='${include help/params/gen/xsd/gen.xsd.comp.complexType.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.xsd.comp.complexType.names';
		param.title='Names';
		param.description='${include help/params/gen/xsd/gen.xsd.comp.complexType.names.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='gen.xsd.comp.simpleType';
		param.title='Simple Types';
		param.description='${include help/params/gen/xsd/gen.xsd.comp.simpleType.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.xsd.comp.simpleType.names';
		param.title='Names';
		param.description='${include help/params/gen/xsd/gen.xsd.comp.simpleType.names.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='gen.xsd.comp.group';
		param.title='Element Groups';
		param.description='${include help/params/gen/xsd/gen.xsd.comp.group.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.xsd.comp.group.names';
		param.title='Names';
		param.description='${include help/params/gen/xsd/gen.xsd.comp.group.names.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='gen.xsd.comp.attribute';
		param.title='Global Attributes';
		param.description='${include help/params/gen/xsd/gen.xsd.comp.attribute.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.xsd.comp.attribute.names';
		param.title='Names';
		param.description='${include help/params/gen/xsd/gen.xsd.comp.attribute.names.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='gen.xsd.comp.attributeGroup';
		param.title='Attribute Groups';
		param.description='${include help/params/gen/xsd/gen.xsd.comp.attributeGroup.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.xsd.comp.attributeGroup.names';
		param.title='Names';
		param.description='${include help/params/gen/xsd/gen.xsd.comp.attributeGroup.names.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='gen.xmlnsBindings';
		param.title='XML Namespace Bindings';
		param.description='${include help/params/gen/gen.xmlnsBindings.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc';
		param.title='Details';
		param.title.style.bold='true';
		param.description='${include help/params/doc/doc.htm}';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='doc.frgm';
		param.title='Fragments';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/doc.frgm.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.frgm.wsdl.files';
		param.title='WSDL File Summary';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/files/doc.frgm.wsdl.files.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.frgm.wsdl.files.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/files/doc.frgm.wsdl.files.sorting.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.sorting.wsdl.files")';
	}
	PARAM={
		param.name='doc.frgm.wsdl.files.description';
		param.title='Description';
		param.description='${include help/params/doc/frgm/wsdl/files/doc.frgm.wsdl.files.description.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
	}
	PARAM={
		param.name='doc.frgm.wsdl.files.profile';
		param.title='WSDL File Profile';
		param.description='${include help/params/doc/frgm/wsdl/files/doc.frgm.wsdl.files.profile.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.wsdl.files.profile.targetNamespace';
		param.title='Target Namespace';
		param.description='${include help/params/doc/wsdl/file/doc.wsdl.file.overview.profile.targetNamespace.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.wsdl.files.profile.types.schemas';
		param.title='Types / Schemas';
		param.description='${include help/params/doc/wsdl/file/doc.wsdl.file.overview.profile.types.schemas.htm}';
		param.type='enum';
		param.enum.values='list;summary;none';
	}
	PARAM={
		param.name='doc.frgm.wsdl.files.profile.defs';
		param.title='WSDL Definitions';
		param.description='${include help/params/doc/wsdl/file/doc.wsdl.file.overview.profile.defs.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.wsdl.files.profile.relatedWSDLs';
		param.title='Related WSDL Files';
		param.description='${include help/params/doc/wsdl/file/doc.wsdl.file.overview.profile.relatedWSDLs.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.schemas';
		param.title='Schema Summary';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.schemas.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.sorting.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.sorting.xsd.schemas")';
	}
	PARAM={
		param.name='doc.frgm.xsd.schemas.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.annotation.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
	}
	PARAM={
		param.name='doc.frgm.xsd.schemas.profile';
		param.title='Schema Profile';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.schemas.profile.targetNamespace';
		param.title='Target Namespace';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.targetNamespace.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.schemas.profile.version';
		param.title='Version';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.version.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.schemas.profile.components';
		param.title='Components';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.components.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.schemas.profile.formDefault';
		param.title='Default NS-Qualified Form';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.formDefault.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.schemas.profile.blockDefault';
		param.title='Default Block Attribute';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.blockDefault.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.schemas.profile.blockDefault.value';
		param.title='Value';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.blockDefault.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.schemas.profile.blockDefault.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.blockDefault.meaning.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.schemas.profile.finalDefault';
		param.title='Default Final Attribute';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.finalDefault.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.schemas.profile.finalDefault.value';
		param.title='Value';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.finalDefault.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.schemas.profile.finalDefault.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.finalDefault.meaning.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.schemas.profile.relatedSchemas';
		param.title='Related Schemas';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.relatedSchemas.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.wsdl.defs';
		param.title='WSDL Definition Summary';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.frgm.wsdl.defs.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.frgm.wsdl.defs.for.services';
		param.title='Services';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.for.services.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.wsdl.def.service")';
	}
	PARAM={
		param.name='doc.frgm.wsdl.defs.for.bindings';
		param.title='Bindings';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.for.bindings.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.wsdl.def.binding")';
	}
	PARAM={
		param.name='doc.frgm.wsdl.defs.for.portTypes';
		param.title='Port Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.for.portTypes.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.wsdl.def.portType")';
	}
	PARAM={
		param.name='doc.frgm.wsdl.defs.for.messages';
		param.title='Messages';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.for.messages.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.wsdl.def.message")';
	}
	PARAM={
		param.name='doc.frgm.wsdl.defs.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.sorting.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.sorting.wsdl.defs")';
	}
	PARAM={
		param.name='doc.frgm.wsdl.defs.description';
		param.title='Description';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.description.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
	}
	PARAM={
		param.name='doc.frgm.wsdl.defs.profile';
		param.title='Definition Profile';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.profile.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.wsdl.defs.profile.namespace';
		param.title='Namespace';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.profile.namespace.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.frgm.wsdl.defs.profile.portType';
		param.title='Port Type';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.profile.portType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.wsdl.defs.profile.includes';
		param.title='Includes';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.profile.includes.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.wsdl.defs.profile.defined';
		param.title='Defined / XML Source';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.profile.defined.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.wsdl.defs.profile.used';
		param.title='Used';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.profile.used.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps';
		param.title='XSD Component Summary';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.for.elements';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.elements.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.xsd.comp.element")';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.for.elements.local';
		param.title='Local Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.elements.local.htm}';
		param.type='enum';
		param.enum.values='all;complexType;none';
		param.enum.displayValues='all;with complex type;none';
		param.defaultValue.expr='getStringParam("gen.xsd.comp.element.local")';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.for.complexTypes';
		param.title='Complex Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.complexTypes.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.xsd.comp.complexType")';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.for.simpleTypes';
		param.title='Simple Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.simpleTypes.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.xsd.comp.simpleType")';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.for.groups';
		param.title='Element Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.groups.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.xsd.comp.group")';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.for.attributes';
		param.title='Global Attributes';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.attributes.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.xsd.comp.attribute")';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.for.attributeGroups';
		param.title='Attribute Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.attributeGroups.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.xsd.comp.attributeGroup")';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.sorting.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.sorting.xsd.comps")';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.annotation.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.profile';
		param.title='Component Profile';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.profile.namespace';
		param.title='Namespace';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.namespace.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.profile.type';
		param.title='Type';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.type.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.profile.content';
		param.title='Content';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.content.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.profile.abstract';
		param.title='Abstract';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.abstract.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.profile.block';
		param.title='Block';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.block.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.profile.block.value';
		param.title='Value';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.block.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.profile.block.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.block.meaning.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.profile.final';
		param.title='Final';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.final.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.profile.final.value';
		param.title='Value';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.final.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.profile.final.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.final.meaning.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.profile.subst';
		param.title='Subst.Gr';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.subst.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.profile.subst.heads';
		param.title='List of group heads';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.subst.heads.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.profile.subst.members';
		param.title='List of group members';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.subst.members.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.profile.nillable';
		param.title='Nillable';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.nillable.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.profile.defined';
		param.title='Defined';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.defined.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.profile.includes';
		param.title='Includes';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.includes.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.profile.redefines';
		param.title='Redefines';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.redefines.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.profile.redefined';
		param.title='Redefined';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.redefined.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.xsd.comps.profile.used';
		param.title='Used';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.used.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.overview';
		param.title='Overview Summary';
		param.title.style.bold='true';
		param.description='${include help/params/doc/overview/doc.overview.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.overview.description';
		param.title='Description';
		param.description='${include help/params/doc/overview/doc.overview.description.htm}';
		param.type='text';
	}
	PARAM={
		param.name='doc.overview.namespaces';
		param.title='Namespace Summary';
		param.description='${include help/params/doc/overview/doc.overview.namespaces.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.overview.namespaces.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc/overview/doc.overview.namespaces.sorting.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.sorting.namespaces")';
	}
	PARAM={
		param.name='doc.overview.wsdl.files';
		param.title='WSDL File Summary';
		param.description='${include help/params/doc/overview/doc.overview.wsdl.files.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.overview.wsdl.files.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/files/doc.frgm.wsdl.files.sorting$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.files.sorting")';
	}
	PARAM={
		param.name='doc.overview.wsdl.files.description';
		param.title='Description';
		param.description='${include help/params/doc/frgm/wsdl/files/doc.frgm.wsdl.files.description$.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
		param.defaultValue.expr='getStringParam("doc.frgm.wsdl.files.description")';
	}
	PARAM={
		param.name='doc.overview.wsdl.files.profile';
		param.title='WSDL File Profile';
		param.description='${include help/params/doc/frgm/wsdl/files/doc.frgm.wsdl.files.profile$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.files.profile")';
	}
	PARAM={
		param.name='doc.overview.wsdl.files.profile.targetNamespace';
		param.title='Target Namespace';
		param.description='${include help/params/doc/frgm/wsdl/files/doc.frgm.wsdl.files.profile.targetNamespace$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.files.profile.targetNamespace")';
	}
	PARAM={
		param.name='doc.overview.wsdl.files.profile.types.schemas';
		param.title='Types / Schemas';
		param.description='${include help/params/doc/wsdl/file/doc.wsdl.file.overview.profile.types.schemas.htm}';
		param.type='enum';
		param.enum.values='list;summary;none';
		param.defaultValue='summary';
	}
	PARAM={
		param.name='doc.overview.wsdl.files.profile.defs';
		param.title='WSDL Definitions';
		param.description='${include help/params/doc/frgm/wsdl/files/doc.frgm.wsdl.files.profile.defs$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.files.profile.defs")';
	}
	PARAM={
		param.name='doc.overview.wsdl.files.profile.relatedWSDLs';
		param.title='Related WSDL Files';
		param.description='${include help/params/doc/frgm/wsdl/files/doc.frgm.wsdl.files.profile.relatedWSDLs$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.files.profile.relatedWSDLs")';
	}
	PARAM={
		param.name='doc.overview.xsd.files';
		param.title='Schema File Summary';
		param.description='${include help/params/doc/overview/doc.overview.xsd.files.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.overview.xsd.files.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.sorting$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.sorting")';
	}
	PARAM={
		param.name='doc.overview.xsd.files.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.annotation$.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
		param.defaultValue.expr='getStringParam("doc.frgm.xsd.schemas.annotation")';
	}
	PARAM={
		param.name='doc.overview.xsd.files.profile';
		param.title='Schema Profile';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile")';
	}
	PARAM={
		param.name='doc.overview.xsd.files.profile.targetNamespace';
		param.title='Target Namespace';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.targetNamespace$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.targetNamespace")';
	}
	PARAM={
		param.name='doc.overview.xsd.files.profile.version';
		param.title='Version';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.version$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.version")';
	}
	PARAM={
		param.name='doc.overview.xsd.files.profile.components';
		param.title='Components';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.components$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.components")';
	}
	PARAM={
		param.name='doc.overview.xsd.files.profile.formDefault';
		param.title='Default NS-Qualified Form';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.formDefault$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.formDefault")';
	}
	PARAM={
		param.name='doc.overview.xsd.files.profile.blockDefault';
		param.title='Default Block Attribute';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.blockDefault$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.blockDefault")';
	}
	PARAM={
		param.name='doc.overview.xsd.files.profile.blockDefault.value';
		param.title='Value';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.blockDefault.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.blockDefault.value")';
	}
	PARAM={
		param.name='doc.overview.xsd.files.profile.blockDefault.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.blockDefault.meaning$.htm}';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.blockDefault.meaning")';
	}
	PARAM={
		param.name='doc.overview.xsd.files.profile.finalDefault';
		param.title='Default Final Attribute';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.finalDefault$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.finalDefault")';
	}
	PARAM={
		param.name='doc.overview.xsd.files.profile.finalDefault.value';
		param.title='Value';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.finalDefault.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.finalDefault.value")';
	}
	PARAM={
		param.name='doc.overview.xsd.files.profile.finalDefault.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.finalDefault.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.finalDefault.meaning")';
	}
	PARAM={
		param.name='doc.overview.xsd.files.profile.relatedSchemas';
		param.title='Related Schemas';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.relatedSchemas$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.relatedSchemas")';
	}
	PARAM={
		param.name='doc.allcomps';
		param.title='All Component Summary';
		param.title.style.bold='true';
		param.description='${include help/params/doc/allcomps/doc.allcomps.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.allcomps.wsdl.defs';
		param.title='WSDL Definition Summary';
		param.description='${include help/params/doc/allcomps/doc.allcomps.wsdl.defs.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.wsdl.def")';
	}
	PARAM={
		param.name='doc.allcomps.wsdl.defs.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.for$.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.allcomps.wsdl.defs.for.services';
		param.title='Services';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.for.services$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.for.services")';
	}
	PARAM={
		param.name='doc.allcomps.wsdl.defs.for.bindings';
		param.title='Bindings';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.for.bindings$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.for.bindings")';
	}
	PARAM={
		param.name='doc.allcomps.wsdl.defs.for.portTypes';
		param.title='Port Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.for.portTypes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.for.portTypes")';
	}
	PARAM={
		param.name='doc.allcomps.wsdl.defs.for.messages';
		param.title='Messages';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.for.messages$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.for.messages")';
	}
	PARAM={
		param.name='doc.allcomps.wsdl.defs.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.sorting$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.sorting")';
	}
	PARAM={
		param.name='doc.allcomps.wsdl.defs.description';
		param.title='Description';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.description$.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
		param.defaultValue.expr='getStringParam("doc.frgm.wsdl.defs.description")';
	}
	PARAM={
		param.name='doc.allcomps.wsdl.defs.profile';
		param.title='Definition Profile';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.profile$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.profile")';
	}
	PARAM={
		param.name='doc.allcomps.wsdl.defs.profile.namespace';
		param.title='Namespace';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.profile.namespace.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.allcomps.wsdl.defs.profile.portType';
		param.title='Port Type';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.profile.portType$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.profile.portType")';
	}
	PARAM={
		param.name='doc.allcomps.wsdl.defs.profile.includes';
		param.title='Includes';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.profile.includes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.profile.includes")';
	}
	PARAM={
		param.name='doc.allcomps.wsdl.defs.profile.defined';
		param.title='Defined / XML Source';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.profile.defined$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.profile.defined")';
	}
	PARAM={
		param.name='doc.allcomps.wsdl.defs.profile.used';
		param.title='Used';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.profile.used$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.profile.used")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps';
		param.title='XSD Component Summary';
		param.description='${include help/params/doc/allcomps/doc.allcomps.xsd.comps.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.xsd.comp")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for$.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.for.elements';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.elements$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.for.elements")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.for.elements.local';
		param.title='Local Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.elements.local$.htm}';
		param.type='enum';
		param.enum.values='all;complexType;none';
		param.enum.displayValues='all;with complex type;none';
		param.defaultValue.expr='getStringParam("doc.frgm.xsd.comps.for.elements.local")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.for.complexTypes';
		param.title='Complex Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.complexTypes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.for.complexTypes")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.for.simpleTypes';
		param.title='Simple Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.simpleTypes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.for.simpleTypes")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.for.groups';
		param.title='Element Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.groups$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.for.groups")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.for.attributes';
		param.title='Global Attributes';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.attributes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.for.attributes")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.for.attributeGroups';
		param.title='Attribute Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.attributeGroups$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.for.attributeGroups")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.sorting$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.sorting")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.annotation$.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
		param.defaultValue.expr='getStringParam("doc.frgm.xsd.comps.annotation")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.profile';
		param.title='Component Profile';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.profile.namespace';
		param.title='Namespace';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.namespace.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.profile.type';
		param.title='Type';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.type$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.type")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.profile.content';
		param.title='Content';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.content$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.content")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.profile.abstract';
		param.title='Abstract';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.abstract$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.abstract")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.profile.block';
		param.title='Block';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.block$.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
		param.defaultValue.expr='getStringParam("doc.frgm.xsd.comps.profile.block")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.profile.block.value';
		param.title='Value';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.block.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.block.value")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.profile.block.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.block.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.block.meaning")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.profile.final';
		param.title='Final';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.final$.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
		param.defaultValue.expr='getStringParam("doc.frgm.xsd.comps.profile.final")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.profile.final.value';
		param.title='Value';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.final.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.final.value")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.profile.final.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.final.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.final.meaning")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.profile.subst';
		param.title='Subst.Gr';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.subst$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.subst")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.profile.subst.heads';
		param.title='List of group heads';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.subst.heads$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.subst.heads")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.profile.subst.members';
		param.title='List of group members';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.subst.members$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.subst.members")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.profile.nillable';
		param.title='Nillable';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.nillable$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.nillable")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.profile.defined';
		param.title='Defined';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.defined$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.defined")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.profile.includes';
		param.title='Includes';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.includes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.includes")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.profile.redefines';
		param.title='Redefines';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.redefines$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.redefines")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.profile.redefined';
		param.title='Redefined';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.redefined$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.redefined")';
	}
	PARAM={
		param.name='doc.allcomps.xsd.comps.profile.used';
		param.title='Used';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.used$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.used")';
	}
	PARAM={
		param.name='doc.namespace';
		param.title='Namespace Overview';
		param.title.style.bold='true';
		param.description='${include help/params/doc/namespace/doc.namespace.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.namespace.profile';
		param.title='Namespace Profile';
		param.description='${include help/params/doc/namespace/doc.namespace.profile.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.namespace.wsdl.files';
		param.title='WSDL File Summary';
		param.description='${include help/params/doc/namespace/doc.namespace.wsdl.files.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.namespace.wsdl.files.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/files/doc.frgm.wsdl.files.sorting$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.files.sorting")';
	}
	PARAM={
		param.name='doc.namespace.wsdl.files.description';
		param.title='Description';
		param.description='${include help/params/doc/frgm/wsdl/files/doc.frgm.wsdl.files.description$.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
		param.defaultValue.expr='getStringParam("doc.frgm.wsdl.files.description")';
	}
	PARAM={
		param.name='doc.namespace.wsdl.files.profile';
		param.title='WSDL File Profile';
		param.description='${include help/params/doc/frgm/wsdl/files/doc.frgm.wsdl.files.profile$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.files.profile")';
	}
	PARAM={
		param.name='doc.namespace.wsdl.files.profile.targetNamespace';
		param.title='Target Namespace';
		param.description='${include help/params/doc/frgm/wsdl/files/doc.frgm.wsdl.files.profile.targetNamespace$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.files.profile.targetNamespace")';
	}
	PARAM={
		param.name='doc.namespace.wsdl.files.profile.types.schemas';
		param.title='Types / Schemas';
		param.description='${include help/params/doc/frgm/wsdl/files/doc.frgm.wsdl.files.profile.types.schemas$.htm}';
		param.type='enum';
		param.enum.values='list;summary;none';
		param.defaultValue.expr='getStringParam("doc.frgm.wsdl.files.profile.types.schemas")';
	}
	PARAM={
		param.name='doc.namespace.wsdl.files.profile.defs';
		param.title='WSDL Definitions';
		param.description='${include help/params/doc/frgm/wsdl/files/doc.frgm.wsdl.files.profile.defs$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.files.profile.defs")';
	}
	PARAM={
		param.name='doc.namespace.wsdl.files.profile.relatedWSDLs';
		param.title='Related WSDL Files';
		param.description='${include help/params/doc/frgm/wsdl/files/doc.frgm.wsdl.files.profile.relatedWSDLs$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.files.profile.relatedWSDLs")';
	}
	PARAM={
		param.name='doc.namespace.wsdl.defs';
		param.title='WSDL Definition Summary';
		param.description='${include help/params/doc/namespace/doc.namespace.wsdl.defs.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.wsdl.def")';
	}
	PARAM={
		param.name='doc.namespace.wsdl.defs.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.for$.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.namespace.wsdl.defs.for.services';
		param.title='Services';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.for.services$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.for.services")';
	}
	PARAM={
		param.name='doc.namespace.wsdl.defs.for.bindings';
		param.title='Bindings';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.for.bindings$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.for.bindings")';
	}
	PARAM={
		param.name='doc.namespace.wsdl.defs.for.portTypes';
		param.title='Port Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.for.portTypes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.for.portTypes")';
	}
	PARAM={
		param.name='doc.namespace.wsdl.defs.for.messages';
		param.title='Messages';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.for.messages$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.for.messages")';
	}
	PARAM={
		param.name='doc.namespace.wsdl.defs.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.sorting$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.sorting")';
	}
	PARAM={
		param.name='doc.namespace.wsdl.defs.description';
		param.title='Description';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.description$.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
		param.defaultValue.expr='getStringParam("doc.frgm.wsdl.defs.description")';
	}
	PARAM={
		param.name='doc.namespace.wsdl.defs.profile';
		param.title='Definition Profile';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.profile$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.profile")';
	}
	PARAM={
		param.name='doc.namespace.wsdl.defs.profile.namespace';
		param.title='Namespace';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.profile.namespace$.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.namespace.wsdl.defs.profile.portType';
		param.title='Port Type';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.profile.portType$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.profile.portType")';
	}
	PARAM={
		param.name='doc.namespace.wsdl.defs.profile.includes';
		param.title='Includes';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.profile.includes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.profile.includes")';
	}
	PARAM={
		param.name='doc.namespace.wsdl.defs.profile.defined';
		param.title='Defined / XML Source';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.profile.defined$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.profile.defined")';
	}
	PARAM={
		param.name='doc.namespace.wsdl.defs.profile.used';
		param.title='Used';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.profile.used$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.profile.used")';
	}
	PARAM={
		param.name='doc.namespace.xsd.schemas';
		param.title='Schema Summary';
		param.description='${include help/params/doc/namespace/doc.namespace.xsd.schemas.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.namespace.xsd.schemas.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.sorting$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.sorting")';
	}
	PARAM={
		param.name='doc.namespace.xsd.schemas.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.annotation$.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
		param.defaultValue.expr='getStringParam("doc.frgm.xsd.schemas.annotation")';
	}
	PARAM={
		param.name='doc.namespace.xsd.schemas.profile';
		param.title='Schema Profile';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile")';
	}
	PARAM={
		param.name='doc.namespace.xsd.schemas.profile.targetNamespace';
		param.title='Target Namespace';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.targetNamespace$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.targetNamespace")';
	}
	PARAM={
		param.name='doc.namespace.xsd.schemas.profile.version';
		param.title='Version';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.version$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.version")';
	}
	PARAM={
		param.name='doc.namespace.xsd.schemas.profile.components';
		param.title='Components';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.components$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.components")';
	}
	PARAM={
		param.name='doc.namespace.xsd.schemas.profile.formDefault';
		param.title='Default NS-Qualified Form';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.formDefault$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.formDefault")';
	}
	PARAM={
		param.name='doc.namespace.xsd.schemas.profile.blockDefault';
		param.title='Default Block Attribute';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.blockDefault$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.blockDefault")';
	}
	PARAM={
		param.name='doc.namespace.xsd.schemas.profile.blockDefault.value';
		param.title='Value';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.blockDefault.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.blockDefault.value")';
	}
	PARAM={
		param.name='doc.namespace.xsd.schemas.profile.blockDefault.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.blockDefault.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.blockDefault.meaning")';
	}
	PARAM={
		param.name='doc.namespace.xsd.schemas.profile.finalDefault';
		param.title='Default Final Attribute';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.finalDefault$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.finalDefault")';
	}
	PARAM={
		param.name='doc.namespace.xsd.schemas.profile.finalDefault.value';
		param.title='Value';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.finalDefault.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.finalDefault.value")';
	}
	PARAM={
		param.name='doc.namespace.xsd.schemas.profile.finalDefault.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.finalDefault.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.finalDefault.meaning")';
	}
	PARAM={
		param.name='doc.namespace.xsd.schemas.profile.relatedSchemas';
		param.title='Related Schemas';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.relatedSchemas$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.relatedSchemas")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps';
		param.title='XSD Component Summary';
		param.description='${include help/params/doc/namespace/doc.namespace.xsd.comps.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.xsd.comp")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for$.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.for.elements';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.elements$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.for.elements")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.for.elements.local';
		param.title='Local Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.elements.local$.htm}';
		param.type='enum';
		param.enum.values='all;complexType;none';
		param.enum.displayValues='all;with complex type;none';
		param.defaultValue.expr='getStringParam("doc.frgm.xsd.comps.for.elements.local")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.for.complexTypes';
		param.title='Complex Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.complexTypes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.for.complexTypes")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.for.simpleTypes';
		param.title='Simple Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.simpleTypes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.for.simpleTypes")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.for.groups';
		param.title='Element Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.groups$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.for.groups")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.for.attributes';
		param.title='Global Attributes';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.attributes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.for.attributes")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.for.attributeGroups';
		param.title='Attribute Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.attributeGroups$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.for.attributeGroups")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.sorting$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.sorting")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.annotation$.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
		param.defaultValue.expr='getStringParam("doc.frgm.xsd.comps.annotation")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.profile';
		param.title='Component Profile';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.profile.namespace';
		param.title='Namespace';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.namespace$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.namespace")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.profile.type';
		param.title='Type';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.type$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.type")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.profile.content';
		param.title='Content';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.content$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.content")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.profile.abstract';
		param.title='Abstract';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.abstract$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.abstract")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.profile.block';
		param.title='Block';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.block$.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
		param.defaultValue.expr='getStringParam("doc.frgm.xsd.comps.profile.block")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.profile.block.value';
		param.title='Value';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.block.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.block.value")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.profile.block.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.block.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.block.meaning")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.profile.final';
		param.title='Final';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.final$.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
		param.defaultValue.expr='getStringParam("doc.frgm.xsd.comps.profile.final")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.profile.final.value';
		param.title='Value';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.final.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.final.value")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.profile.final.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.final.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.final.meaning")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.profile.subst';
		param.title='Subst.Gr';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.subst$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.subst")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.profile.subst.heads';
		param.title='List of group heads';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.subst.heads$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.subst.heads")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.profile.subst.members';
		param.title='List of group members';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.subst.members$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.subst.members")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.profile.nillable';
		param.title='Nillable';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.nillable$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.nillable")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.profile.defined';
		param.title='Defined';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.defined$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.defined")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.profile.includes';
		param.title='Includes';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.includes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.includes")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.profile.redefines';
		param.title='Redefines';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.redefines$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.redefines")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.profile.redefined';
		param.title='Redefined';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.redefined$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.redefined")';
	}
	PARAM={
		param.name='doc.namespace.xsd.comps.profile.used';
		param.title='Used';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.used$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.used")';
	}
	PARAM={
		param.name='doc.wsdl.file';
		param.title='WSDL File';
		param.title.style.bold='true';
		param.description='${include help/params/doc/wsdl/file/doc.wsdl.file.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.wsdl.file.overview';
		param.title='Overview';
		param.title.style.bold='true';
		param.description='${include help/params/doc/wsdl/file/doc.wsdl.file.overview.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.profile';
		param.title='WSDL File Profile';
		param.description='${include help/params/doc/wsdl/file/doc.wsdl.file.overview.profile.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.profile.targetNamespace';
		param.title='Target Namespace';
		param.description='${include help/params/doc/wsdl/file/doc.wsdl.file.overview.profile.targetNamespace.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.profile.types.schemas';
		param.title='Types / Schemas';
		param.description='${include help/params/doc/wsdl/file/doc.wsdl.file.overview.profile.types.schemas.htm}';
		param.type='enum';
		param.enum.values='list;summary;none';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.profile.defs';
		param.title='WSDL Definitions';
		param.description='${include help/params/doc/wsdl/file/doc.wsdl.file.overview.profile.defs.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.profile.relatedWSDLs';
		param.title='Related WSDL Files';
		param.description='${include help/params/doc/wsdl/file/doc.wsdl.file.overview.profile.relatedWSDLs.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.description';
		param.title='Description';
		param.description='${include help/params/doc/wsdl/file/doc.wsdl.file.overview.description.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.schemas';
		param.title='Embedded Schema Summary';
		param.description='${include help/params/doc/wsdl/file/doc.wsdl.file.overview.schemas.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.schemas.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.annotation$.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
		param.defaultValue.expr='getStringParam("doc.frgm.xsd.schemas.annotation")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.schemas.profile';
		param.title='Schema Profile';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.schemas.profile.targetNamespace';
		param.title='Target Namespace';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.targetNamespace$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.targetNamespace")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.schemas.profile.version';
		param.title='Version';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.version$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.version")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.schemas.profile.components';
		param.title='Components';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.components$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.components")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.schemas.profile.formDefault';
		param.title='Default NS-Qualified Form';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.formDefault$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.formDefault")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.schemas.profile.blockDefault';
		param.title='Default Block Attribute';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.blockDefault$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.blockDefault")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.schemas.profile.blockDefault.value';
		param.title='Value';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.blockDefault.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.blockDefault.value")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.schemas.profile.blockDefault.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.blockDefault.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.blockDefault.meaning")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.schemas.profile.finalDefault';
		param.title='Default Final Attribute';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.finalDefault$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.finalDefault")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.schemas.profile.finalDefault.value';
		param.title='Value';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.finalDefault.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.finalDefault.value")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.schemas.profile.finalDefault.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.finalDefault.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.finalDefault.meaning")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.schemas.profile.relatedSchemas';
		param.title='Related Schemas';
		param.description='${include help/params/doc/frgm/xsd/schemas/doc.frgm.xsd.schemas.profile.relatedSchemas$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.schemas.profile.relatedSchemas")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.defs';
		param.title='WSDL Definition Summary';
		param.description='${include help/params/doc/wsdl/file/doc.wsdl.file.overview.defs.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.wsdl.def")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.defs.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.for$.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.defs.for.services';
		param.title='Services';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.for.services$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.for.services")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.defs.for.bindings';
		param.title='Bindings';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.for.bindings$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.for.bindings")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.defs.for.portTypes';
		param.title='Port Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.for.portTypes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.for.portTypes")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.defs.for.messages';
		param.title='Messages';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.for.messages$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.for.messages")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.defs.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.sorting$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.sorting")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.defs.description';
		param.title='Description';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.description$.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
		param.defaultValue.expr='getStringParam("doc.frgm.wsdl.defs.description")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.defs.profile';
		param.title='Definition Profile';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.profile$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.profile")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.defs.profile.namespace';
		param.title='Namespace';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.profile.namespace$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.profile.namespace")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.defs.profile.portType';
		param.title='Port Type';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.profile.portType$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.profile.portType")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.defs.profile.includes';
		param.title='Includes';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.profile.includes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.profile.includes")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.defs.profile.defined';
		param.title='Defined / XML Source';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.profile.defined$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.profile.defined")';
	}
	PARAM={
		param.name='doc.wsdl.file.overview.defs.profile.used';
		param.title='Used';
		param.description='${include help/params/doc/frgm/wsdl/defs/doc.frgm.wsdl.defs.profile.used$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.wsdl.defs.profile.used")';
	}
	PARAM={
		param.name='doc.wsdl.file.source';
		param.title='XML Source';
		param.title.style.bold='true';
		param.description='${include help/params/doc/wsdl/file/doc.wsdl.file.source.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.wsdl.file.source.join.overview';
		param.title='Join with Overview';
		param.description='${include help/params/doc/wsdl/file/doc.wsdl.file.source.join.overview.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.wsdl.file.source.box';
		param.title='Enclose in Box';
		param.description='${include help/params/doc/wsdl/file/doc.wsdl.file.source.box.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.wsdl.file.source.remove.wsdl.docs';
		param.title='Remove <wsdl:documentation>';
		param.description='${include help/params/doc/wsdl/file/doc.wsdl.file.source.remove.wsdl.docs.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.wsdl.file.source.remove.xsd.anns';
		param.title='Remove <xs:annotation>';
		param.description='${include help/params/doc/wsdl/file/doc.wsdl.file.source.remove.xsd.anns.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema';
		param.title='Schema';
		param.title.style.bold='true';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.schema.overview';
		param.title='Overview';
		param.title.style.bold='true';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile';
		param.title='Schema Profile';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.targetNamespace';
		param.title='Target Namespace';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.targetNamespace.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.version';
		param.title='Version';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.version.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.components';
		param.title='Components';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.components.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.formDefault';
		param.title='Default NS-Qualified Form';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.formDefault.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.blockDefault';
		param.title='Default Block Attribute';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.blockDefault.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.blockDefault.value';
		param.title='Value';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.blockDefault.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.blockDefault.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.blockDefault.meaning.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.finalDefault';
		param.title='Default Final Attribute';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.finalDefault.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.finalDefault.value';
		param.title='Value';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.finalDefault.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.finalDefault.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.finalDefault.meaning.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.relatedSchemas';
		param.title='Related Schemas';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.profile.relatedSchemas.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.annotation.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps';
		param.title='XSD Component Summary';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.overview.comps.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.xsd.comp")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for$.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.for.elements';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.elements$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.for.elements")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.for.elements.local';
		param.title='Local Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.elements.local$.htm}';
		param.type='enum';
		param.enum.values='all;complexType;none';
		param.enum.displayValues='all;with complex type;none';
		param.defaultValue.expr='getStringParam("doc.frgm.xsd.comps.for.elements.local")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.for.complexTypes';
		param.title='Complex Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.complexTypes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.for.complexTypes")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.for.simpleTypes';
		param.title='Simple Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.simpleTypes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.for.simpleTypes")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.for.groups';
		param.title='Element Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.groups$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.for.groups")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.for.attributes';
		param.title='Global Attributes';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.attributes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.for.attributes")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.for.attributeGroups';
		param.title='Attribute Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.for.attributeGroups$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.for.attributeGroups")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.sorting$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.sorting")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.annotation$.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
		param.defaultValue.expr='getStringParam("doc.frgm.xsd.comps.annotation")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile';
		param.title='Component Profile';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.namespace';
		param.title='Namespace';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.namespace$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.namespace")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.type';
		param.title='Type';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.type$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.type")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.content';
		param.title='Content';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.content$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.content")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.abstract';
		param.title='Abstract';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.abstract$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.abstract")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.block';
		param.title='Block';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.block$.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
		param.defaultValue.expr='getStringParam("doc.frgm.xsd.comps.profile.block")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.block.value';
		param.title='Value';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.block.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.block.value")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.block.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.block.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.block.meaning")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.final';
		param.title='Final';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.final$.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
		param.defaultValue.expr='getStringParam("doc.frgm.xsd.comps.profile.final")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.final.value';
		param.title='Value';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.final.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.final.value")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.final.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.final.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.final.meaning")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.subst';
		param.title='Subst.Gr';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.subst$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.subst")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.subst.heads';
		param.title='List of group heads';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.subst.heads$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.subst.heads")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.subst.members';
		param.title='List of group members';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.subst.members$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.subst.members")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.nillable';
		param.title='Nillable';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.nillable$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.nillable")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.defined';
		param.title='Defined';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.defined$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.defined")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.includes';
		param.title='Includes';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.includes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.includes")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.redefines';
		param.title='Redefines';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.redefines$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.redefines")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.redefined';
		param.title='Redefined';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.redefined$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.redefined")';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.used';
		param.title='Used';
		param.description='${include help/params/doc/frgm/xsd/comps/doc.frgm.xsd.comps.profile.used$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.xsd.comps.profile.used")';
	}
	PARAM={
		param.name='doc.xsd.schema.source';
		param.title='XML Source';
		param.title.style.bold='true';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.source.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.schema.source.join.overview';
		param.title='Join with Overview';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.source.join.overview.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.source.box';
		param.title='Enclose in Box';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.source.box.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.source.remove.xsd.anns';
		param.title='Remove <xs:annotation>';
		param.description='${include help/params/doc/xsd/schema/doc.xsd.schema.source.remove.xsd.anns.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.wsdl.def';
		param.title='WSDL Definition';
		param.title.style.bold='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.wsdl.def.altDesc';
		param.title='Alternative Descriptions';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.altDesc.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.wsdl.def.altDesc.operation';
		param.title='Operation';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.altDesc.operation.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.wsdl.def.altDesc.operation.copyFrom';
		param.title='Copy From';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.altDesc.operation.copyFrom.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.wsdl.def.altDesc.operation.copyFrom.portType.operation';
		param.title='Port Type Operation';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.altDesc.operation.copyFrom.portType.operation.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.altDesc.operation.copyFrom.input.message';
		param.title='Input Message';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.altDesc.operation.copyFrom.input.message.htm}';
		param.group='true';
		param.group.defaultState='expanded';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.wsdl.def.altDesc.operation.copyFrom.input.message.part.dataType';
		param.title='Data Type';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.altDesc.operation.copyFrom.input.message.part.dataType.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.wsdl.def.altDesc.operation.copyFrom.output.message';
		param.title='Output Message';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.altDesc.operation.copyFrom.output.message.htm}';
		param.group='true';
		param.group.defaultState='expanded';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.wsdl.def.altDesc.operation.copyFrom.output.message.part.dataType';
		param.title='Data Type';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.altDesc.operation.copyFrom.output.message.part.dataType.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.wsdl.def.altDesc.part';
		param.title='Message Part';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.altDesc.part.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.wsdl.def.altDesc.part.copyFrom';
		param.title='Copy From';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.altDesc.part.copyFrom.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.wsdl.def.altDesc.part.copyFrom.dataType';
		param.title='Data Type';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.altDesc.part.copyFrom.dataType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.profile';
		param.title='Definition Profile';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.profile.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.profile.namespace';
		param.title='Namespace';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.profile.namespace.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.profile.portType';
		param.title='Port Type';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.profile.portType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.profile.includes';
		param.title='Includes';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.profile.includes.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.profile.defined';
		param.title='Defined / XML Source';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.profile.defined.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.profile.used';
		param.title='Used';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.profile.used.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.extensibility';
		param.title='Extensibility Elements';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.extensibility.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.usage';
		param.title='Usage Locations';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.usage.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.description';
		param.title='Description';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.description.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operationSummary';
		param.title='Operation Summary';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operationSummary.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operationSummary.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operationSummary.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operationSummary.for.binding';
		param.title='Bindings';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operationSummary.for.binding.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operationSummary.for.portType';
		param.title='Port Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operationSummary.for.portType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.source';
		param.title='XML Source';
		param.title.style.bold='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.source.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.source.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.source.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.wsdl.def.source.for.service';
		param.title='Services';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.source.for.service.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.source.for.binding';
		param.title='Bindings';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.source.for.binding.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.source.for.portType';
		param.title='Port Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.source.for.portType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.source.for.message';
		param.title='Messages';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.source.for.message.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.source.box';
		param.title='Enclose in Box';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.source.box.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.source.remove.wsdl.docs';
		param.title='Remove <wsdl:documentation>';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.source.remove.wsdl.docs.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.ports';
		param.title='Port Detail';
		param.title.style.bold='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.ports.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.ports.description';
		param.title='Description';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.ports.description.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.ports.profile';
		param.title='Profile';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.ports.profile.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.ports.extensibility';
		param.title='Extensibility Elements';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.ports.extensibility.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.ports.source';
		param.title='XML Source';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.ports.source.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.wsdl.def.ports.source.box';
		param.title='Enclose in Box';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.ports.source.box.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.ports.source.remove.wsdl.docs';
		param.title='Remove <wsdl:documentation>';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.ports.source.remove.wsdl.docs.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.ports.operationSummary';
		param.title='Operation Summary';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.ports.operationSummary.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.ports.separator';
		param.title='Separator';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations';
		param.title='Operation Detail';
		param.title.style.bold='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.for.binding';
		param.title='Bindings';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.for.binding.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.for.portType';
		param.title='Port Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.for.portType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.description';
		param.title='Description';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.description.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.profile';
		param.title='Profile';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.profile.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.extensibility';
		param.title='Extensibility Elements';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.extensibility.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.input';
		param.title='Input';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.input.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.input.description';
		param.title='Description';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.input.description.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.input.message';
		param.title='Message';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.input.message.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.input.message.parts';
		param.title='Parts';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.input.message.parts.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.input.message.parts.description';
		param.title='Description';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.input.message.parts.description.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.input.message.parts.description.copyFrom';
		param.title='Copy From';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.input.message.parts.description.copyFrom.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.input.message.parts.description.copyFrom.dataType';
		param.title='Data Type';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.input.message.parts.description.copyFrom.dataType.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.wsdl.def.altDesc.part.copyFrom.dataType")';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.input.extensibility';
		param.title='Extensibility Elements';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.input.extensibility.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.output';
		param.title='Output';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.output.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.output.description';
		param.title='Description';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.output.description.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.output.message';
		param.title='Message';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.output.message.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.output.message.parts';
		param.title='Parts';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.input.message.parts.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.output.message.parts.description';
		param.title='Description';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.input.message.parts.description.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.output.message.parts.description.copyFrom';
		param.title='Copy From';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.input.message.parts.description.copyFrom.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.output.message.parts.description.copyFrom.dataType';
		param.title='Data Type';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.input.message.parts.description.copyFrom.dataType.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.wsdl.def.altDesc.part.copyFrom.dataType")';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.output.extensibility';
		param.title='Extensibility Elements';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.output.extensibility.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.fault';
		param.title='Fault';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.fault.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.fault.description';
		param.title='Description';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.fault.description.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.fault.message';
		param.title='Message';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.fault.message.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.fault.message.parts';
		param.title='Parts';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.input.message.parts.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.fault.message.parts.description';
		param.title='Description';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.input.message.parts.description.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.fault.message.parts.description.copyFrom';
		param.title='Copy From';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.input.message.parts.description.copyFrom.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.fault.message.parts.description.copyFrom.dataType';
		param.title='Data Type';
		param.title.style.italic='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.input.message.parts.description.copyFrom.dataType.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.wsdl.def.altDesc.part.copyFrom.dataType")';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.fault.extensibility';
		param.title='Extensibility Elements';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.fault.extensibility.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.source';
		param.title='XML Source';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.source.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.source.box';
		param.title='Enclose in Box';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.source.box.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.source.remove.wsdl.docs';
		param.title='Remove <wsdl:documentation>';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.operations.source.remove.wsdl.docs.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.operations.separator';
		param.title='Separator';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.parts';
		param.title='Message Part Detail';
		param.title.style.bold='true';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.parts.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.parts.dataType';
		param.title='Data Type';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.parts.dataType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.parts.description';
		param.title='Description';
		param.description='${include help/params/doc/wsdl/def/doc.wsdl.def.parts.description.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.wsdl.def.parts.separator';
		param.title='Separator';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp';
		param.title='XSD Component';
		param.title.style.bold='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.comp.profile';
		param.title='Component Profile';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.profile.namespace';
		param.title='Namespace';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.namespace.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.profile.type';
		param.title='Type';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.type.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.profile.content';
		param.title='Content';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.content.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.profile.abstract';
		param.title='Abstract';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.abstract.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.profile.block';
		param.title='Block';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.block.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
	}
	PARAM={
		param.name='doc.xsd.comp.profile.block.value';
		param.title='Value';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.block.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.profile.block.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.block.meaning.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.profile.final';
		param.title='Final';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.final.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
	}
	PARAM={
		param.name='doc.xsd.comp.profile.final.value';
		param.title='Value';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.final.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.profile.final.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.final.meaning.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.profile.subst';
		param.title='Subst.Gr';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.subst.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.profile.subst.heads';
		param.title='List of group heads';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.subst.heads.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.profile.subst.members';
		param.title='List of group members';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.subst.members.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.comp.profile.nillable';
		param.title='Nillable';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.nillable.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.profile.defined';
		param.title='Defined';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.defined.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.profile.includes';
		param.title='Includes';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.includes.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.profile.redefines';
		param.title='Redefines';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.redefines.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.profile.redefined';
		param.title='Redefined';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.redefined.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.profile.used';
		param.title='Used';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.profile.used.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.diagram';
		param.title='Diagram';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.diagram.htm}';
		param.enablingExpr='getBooleanParam("DiagramKit")
&&
dsmType.imageProvider != null';
		param.group='true';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='getBooleanParam("DiagramKit")
&&
dsmType.imageProvider != null';
	}
	PARAM={
		param.name='doc.xsd.comp.diagram.links';
		param.title='Hyperlinks';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.diagram.links.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.comp.diagram.links.attribute.global';
		param.title='Global Attributes';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.diagram.links.attribute.global.htm}';
		param.type='enum';
		param.enum.values='global;local';
		param.enum.displayValues='global documentation;local documentation';
	}
	PARAM={
		param.name='doc.xsd.comp.diagram.links.element.local';
		param.title='Local Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.diagram.links.element.local.htm}';
		param.type='enum';
		param.enum.values='global;local';
		param.enum.displayValues='global documentation;local documentation';
	}
	PARAM={
		param.name='doc.xsd.comp.diagram.links.compositors';
		param.title='Compositors';
		param.title.style.italic='true';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.xmlRep';
		param.title='XML Representation Summary';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.xmlRep.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.xmlRep.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.xmlRep.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.comp.xmlRep.for.element';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.xmlRep.for.element.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.xmlRep.for.complexType';
		param.title='Complex Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.xmlRep.for.complexType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.xmlRep.for.simpleType';
		param.title='Simple Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.xmlRep.for.simpleType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.xmlRep.for.group';
		param.title='Element Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.xmlRep.for.group.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.xmlRep.for.attribute';
		param.title='Global Attributes';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.xmlRep.for.attribute.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.xmlRep.for.attributeGroup';
		param.title='Attribute Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.xmlRep.for.attributeGroup.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.xmlRep.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.xmlRep.sorting.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.comp.simpleContent';
		param.title='Simple Content Detail';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.simpleContent.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.simpleContent.restrictions';
		param.title='Restrictions';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.simpleContent.restrictions.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.simpleContent.restrictions.annotation';
		param.title='Annotations';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.simpleContent.restrictions.annotation.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.simpleContent.default';
		param.title='Default Value';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.simpleContent.default.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.simpleContent.fixed';
		param.title='Fixed Value';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.simpleContent.fixed.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.lists';
		param.title='Lists of Related Components';
		param.title.style.bold='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.lists.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.lists.layout';
		param.title='List Layout';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.lists.layout.htm}';
		param.type='enum';
		param.enum.values='flow;one_column;two_columns;optimal';
		param.enum.displayValues='flow;one column;two columns;optimal';
		param.defaultValue='optimal';
	}
	PARAM={
		param.name='doc.xsd.comp.lists.contentElements';
		param.title='Content Elements';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.lists.contentElements.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.lists.containingElements';
		param.title='Containing Elements';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.lists.containingElements.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.lists.substitutableElements';
		param.title='Substitutable Elements';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.lists.substitutableElements.htm}';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='! getBooleanParam("doc.xsd.comp.profile.subst.heads")';
	}
	PARAM={
		param.name='doc.xsd.comp.lists.substitutingElements';
		param.title='Substituting Elements';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.lists.substitutingElements.htm}';
		param.type='boolean';
		param.defaultValue.expr='! getBooleanParam("doc.xsd.comp.profile.subst.members")';
	}
	PARAM={
		param.name='doc.xsd.comp.lists.childrenBySubst';
		param.title='Children By Substitutions';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.lists.childrenBySubst.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.lists.parentsBySubst';
		param.title='Parents By Substitutions';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.lists.parentsBySubst.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.lists.directSubtypes';
		param.title='Direct Subtypes';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.lists.directSubtypes.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.lists.indirectSubtypes';
		param.title='Indirect Subtypes';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.lists.indirectSubtypes.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.lists.basedElements';
		param.title='All Based Elements';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.lists.basedElements.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.lists.basedAttributes';
		param.title='All Based Attributes';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.lists.basedAttributes.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.usage';
		param.title='Usage / Definition Locations';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.usage.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.usage.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.usage.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.comp.usage.for.element.global';
		param.title='Global Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.usage.for.element.global.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.usage.for.element.local';
		param.title='Local Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.usage.for.element.local.htm}';
		param.type='enum';
		param.enum.values='always;multiple;never';
		param.enum.displayValues='always;multiple only;never';
		param.defaultValue='multiple';
	}
	PARAM={
		param.name='doc.xsd.comp.usage.for.complexType';
		param.title='Complex Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.usage.for.complexType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.usage.for.simpleType';
		param.title='Simple Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.usage.for.simpleType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.usage.for.group';
		param.title='Element Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.usage.for.group.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.usage.for.attribute';
		param.title='Global Attributes';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.usage.for.attribute.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.usage.for.attributeGroup';
		param.title='Attribute Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.usage.for.attributeGroup.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.usage.layout';
		param.title='List Layout';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.usage.layout.htm}';
		param.type='enum';
		param.enum.values='flow;one_column;two_columns;optimal';
		param.enum.displayValues='flow;one column;two columns;optimal';
		param.defaultValue='optimal';
	}
	PARAM={
		param.name='doc.xsd.comp.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.annotation.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.annotation.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.annotation.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.comp.annotation.for.element';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.annotation.for.element.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.annotation.for.complexType';
		param.title='Complex Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.annotation.for.complexType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.annotation.for.simpleType';
		param.title='Simple Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.annotation.for.simpleType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.annotation.for.group';
		param.title='Element Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.annotation.for.group.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.annotation.for.attribute';
		param.title='Global Attributes';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.annotation.for.attribute.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.annotation.for.attributeGroup';
		param.title='Attribute Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.annotation.for.attributeGroup.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.type';
		param.title='Type Definition Detail';
		param.title.style.bold='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.type.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.type.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.type.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.comp.type.for.element.type';
		param.title='Elements With Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.type.for.element.type.htm}';
		param.type='enum';
		param.enum.values='anonymous;any;none';
	}
	PARAM={
		param.name='doc.xsd.comp.type.for.attribute.type';
		param.title='Attributes With Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.type.for.attribute.type.htm}';
		param.type='enum';
		param.enum.values='anonymous;any;none';
	}
	PARAM={
		param.name='doc.xsd.comp.type.for.type';
		param.title='Global Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.type.for.type.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.type.deriv.tree';
		param.title='Type Derivation Tree';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.type.deriv.tree.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.type.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.type.annotation.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.type.deriv.simpleContent';
		param.title='Simple Content Derivation';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.type.deriv.simpleContent.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='local;full;none';
		param.enum.displayValues='local definition only;full;none';
	}
	PARAM={
		param.name='doc.xsd.comp.type.deriv.simpleContent.facets';
		param.title='Facets';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.type.deriv.simpleContent.facets.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.type.deriv.simpleContent.annotations';
		param.title='Annotations';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.type.deriv.simpleContent.annotations.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.source';
		param.title='XML Source';
		param.title.style.bold='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.source.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.source.box';
		param.title='Enclose in Box';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.source.box.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.comp.source.remove.xsd.anns';
		param.title='Remove <xs:annotation>';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.source.remove.xsd.anns.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes';
		param.title='Attribute Detail';
		param.title.style.bold='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.for.element';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.for.element.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.for.complexType';
		param.title='Complex Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.for.complexType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.for.attributeGroup';
		param.title='Attribute Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.for.attributeGroup.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.include';
		param.title='Include';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.include.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.include.local';
		param.title='Local';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.include.local.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.include.references';
		param.title='References';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.include.references.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.include.wildcard';
		param.title='Wildcard';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.include.wildcard.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.include.prohibitions';
		param.title='Prohibitions';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.include.prohibitions.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.include.inherited';
		param.title='Inherited';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.include.inherited.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.sorting.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.profile';
		param.title='Profile';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.profile.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.profile.form';
		param.title='Form';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.profile.form.htm}';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
		param.defaultValue='non_default';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.profile.type';
		param.title='Type';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.profile.type.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.profile.use';
		param.title='Usage';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.profile.use.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.profile.default';
		param.title='Default Value';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.profile.default.htm}';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='! getBooleanParam("doc.xsd.comp.attributes.value") ||
! getBooleanParam("doc.xsd.comp.attributes.value.default")';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.profile.fixed';
		param.title='Fixed Value';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.profile.fixed.htm}';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='! getBooleanParam("doc.xsd.comp.attributes.value") ||
! getBooleanParam("doc.xsd.comp.attributes.value.fixed")';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.profile.defined';
		param.title='Definition Location';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.profile.defined.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.xsd.comp.attributes.include.inherited")';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.annotation.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.value';
		param.title='Attribute Value';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.value.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.value.model';
		param.title='Datatype Model';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.value.model.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.value.restrictions';
		param.title='Restrictions';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.value.restrictions.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.value.restrictions.annotation';
		param.title='Annotations';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.value.restrictions.annotation.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.value.default';
		param.title='Default Value';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.value.default.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.value.fixed';
		param.title='Fixed Value';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.value.fixed.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.type';
		param.title='Type Detail';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.type.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.type.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.type.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.type.for.attr';
		param.title='Attributes';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.type.for.attr.htm}';
		param.type='enum';
		param.enum.values='local;any';
		param.enum.displayValues='local only;any';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.type.for.typeDecl';
		param.title='Type Declarations';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.type.for.typeDecl.htm}';
		param.type='enum';
		param.enum.values='anonymous;any';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.type.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.type.annotation.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.type.deriv.tree';
		param.title='Type Derivation Tree';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.type.deriv.tree.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.type.deriv.simpleContent';
		param.title='Simple Content Derivation';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.type.deriv.simpleContent.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='local;full;none';
		param.enum.displayValues='local definition only;full;none';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.type.deriv.simpleContent.facets';
		param.title='Facets';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.type.deriv.simpleContent.facets.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.type.deriv.simpleContent.annotations';
		param.title='Annotations';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.type.deriv.simpleContent.annotations.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.source';
		param.title='XML Source';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.source.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.source.box';
		param.title='Enclose in Box';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.source.box.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.source.remove.xsd.anns';
		param.title='Remove <xs:annotation>';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.attributes.source.remove.xsd.anns.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.attributes.separator';
		param.title='Separator';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements';
		param.title='Content Element Detail';
		param.title.style.bold='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.for.element';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.for.element.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.for.complexType';
		param.title='Complex Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.for.complexType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.for.group';
		param.title='Element Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.for.group.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.include';
		param.title='Include';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.include.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.include.local';
		param.title='Local';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.include.local.htm}';
		param.type='enum';
		param.enum.values='all;simpleType;none';
		param.enum.displayValues='all;with simple type only;none';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.include.references';
		param.title='References';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.include.references.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.include.wildcards';
		param.title='Wildcards';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.include.wildcards.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.include.inherited';
		param.title='Inherited';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.include.inherited.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.sorting.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.profile';
		param.title='Profile';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.profile.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.profile.form';
		param.title='Form';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.profile.form.htm}';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
		param.defaultValue='non_default';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.profile.type';
		param.title='Type';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.profile.type.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.profile.abstract';
		param.title='Abstract';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.profile.abstract.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.profile.block';
		param.title='Block';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.profile.block.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
		param.defaultValue='non_default';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.profile.block.value';
		param.title='Value';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.profile.block.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.profile.block.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.profile.block.meaning.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.profile.final';
		param.title='Final';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.profile.final.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
		param.defaultValue='non_default';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.profile.final.value';
		param.title='Value';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.profile.final.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.profile.final.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.profile.final.meaning.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.profile.subst';
		param.title='Subst.Gr';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.profile.subst.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.profile.subst.heads';
		param.title='List of group heads';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.profile.subst.heads.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.profile.subst.members';
		param.title='List of group members';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.profile.subst.members.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.profile.default';
		param.title='Default Value';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.profile.default.htm}';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='! getBooleanParam("doc.xsd.comp.contentElements.simpleContent") ||
! getBooleanParam("doc.xsd.comp.contentElements.simpleContent.default")';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.profile.fixed';
		param.title='Fixed Value';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.profile.fixed.htm}';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='! getBooleanParam("doc.xsd.comp.contentElements.simpleContent") ||
! getBooleanParam("doc.xsd.comp.contentElements.simpleContent.fixed")';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.profile.nillable';
		param.title='Nillable';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.profile.nillable.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.profile.defined';
		param.title='Definition Location';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.profile.defined.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.xsd.comp.contentElements.include.inherited")';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.annotation.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.diagram';
		param.title='Diagram';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.diagram.htm}';
		param.enablingExpr='getBooleanParam("DiagramKit")
&&
dsmType.imageProvider != null';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.xsd.comp.diagram")
&&
(! getBooleanParam("gen.xsd.comp.element") ||
 hasParamValue("gen.xsd.comp.element.local", "none"))';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.diagram.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.diagram.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.diagram.for.element';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.xmlRep.for.element.htm}';
		param.type='enum';
		param.enum.values='local;any';
		param.enum.displayValues='local only;any';
		param.defaultValue.expr='getBooleanParam("gen.xsd.comp.element") ? "local" : "any"';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.diagram.for.type';
		param.title='With Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.xmlRep.for.type.htm}';
		param.type='enum';
		param.enum.values='complexType;any';
		param.enum.displayValues='complex type only;any type';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.diagram.links';
		param.title='Hyperlinks';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.diagram.links.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.diagram.links.attribute.global';
		param.title='Global Attributes';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.diagram.links.attribute.global.htm}';
		param.type='enum';
		param.enum.values='global;local';
		param.enum.displayValues='global documentation;local documentation';
		param.defaultValue.expr='getStringParam("doc.xsd.comp.diagram.links.attribute.global")';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.diagram.links.element.local';
		param.title='Local Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.diagram.links.element.local.htm}';
		param.type='enum';
		param.enum.values='global;local';
		param.enum.displayValues='global documentation;local documentation';
		param.defaultValue.expr='getStringParam("doc.xsd.comp.diagram.links.element.local")';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.diagram.links.element.compositors';
		param.title='Compositors';
		param.title.style.italic='true';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.xsd.comp.diagram.links.compositors")';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.xmlRep';
		param.title='XML Representation Summary';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.xmlRep.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='! getBooleanParam("gen.xsd.comp.element") ||
! hasParamValue("gen.xsd.comp.element.local", "all")';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.xmlRep.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.xmlRep.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.xmlRep.for.element';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.xmlRep.for.element.htm}';
		param.type='enum';
		param.enum.values='local;any';
		param.enum.displayValues='local only;any';
		param.defaultValue.expr='getBooleanParam("gen.xsd.comp.element") ? "local" : "any"';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.xmlRep.for.type';
		param.title='With Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.xmlRep.for.type.htm}';
		param.type='enum';
		param.enum.values='complexType;simpleType;any';
		param.enum.displayValues='complex type;simple type;any type';
		param.defaultValue.expr='hasParamValue("gen.xsd.comp.element.local", "complexType") ?
 "simpleType" : "any"';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.xmlRep.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.xmlRep.sorting.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.xmlRep.heading';
		param.title='Show Heading';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.xmlRep.heading.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.simpleContent';
		param.title='Simple Content';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.simpleContent.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.simpleContent.model';
		param.title='Datatype Model';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.simpleContent.model.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.simpleContent.restrictions';
		param.title='Restrictions';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.simpleContent.restrictions.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.simpleContent.restrictions.annotation';
		param.title='Annotations';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.simpleContent.restrictions.annotation.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.simpleContent.default';
		param.title='Default Value';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.simpleContent.default.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.simpleContent.fixed';
		param.title='Fixed Value';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.simpleContent.fixed.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.children';
		param.title='Possible Children';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.children.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.children.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.children.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.children.for.element';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.children.for.element.htm}';
		param.type='enum';
		param.enum.values='local;any';
		param.enum.displayValues='local only;any';
		param.defaultValue.expr='getBooleanParam("gen.xsd.comp.element") ? "local" : "any"';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.type';
		param.title='Type Detail';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.type.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='! getBooleanParam("gen.xsd.comp.element") ||
! hasParamValue("gen.xsd.comp.element.local", "all")';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.type.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.type.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.type.for.element';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.type.for.element.htm}';
		param.type='enum';
		param.enum.values='local;any';
		param.enum.displayValues='local only;any';
		param.defaultValue.expr='getBooleanParam("gen.xsd.comp.element") ? "local" : "any"';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.type.for.type';
		param.title='Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.type.for.type.htm}';
		param.type='enum';
		param.enum.values='simpleType;any';
		param.enum.displayValues='simple type;any';
		param.defaultValue.expr='getBooleanParam("gen.xsd.comp.element") &&
  hasParamValue("gen.xsd.comp.element.local", "complexType")
? "simpleType" : "any"';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.type.for.typeDecl';
		param.title='Type Declarations';
		param.title.style.italic='true';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.type.for.typeDecl.htm}';
		param.type='enum';
		param.enum.values='anonymous;any';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.type.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.type.annotation.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.type.deriv.tree';
		param.title='Type Derivation Tree';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.type.deriv.tree.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.type.deriv.simpleContent';
		param.title='Simple Content Derivation';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.type.deriv.simpleContent.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='local;full;none';
		param.enum.displayValues='local definition only;full;none';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.type.deriv.simpleContent.facets';
		param.title='Facets';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.type.deriv.simpleContent.facets.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.type.deriv.simpleContent.annotations';
		param.title='Annotations';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.type.deriv.simpleContent.annotations.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.source';
		param.title='XML Source';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.source.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.source.box';
		param.title='Enclose in Box';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.source.box.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.source.remove.xsd.anns';
		param.title='Remove <xs:annotation>';
		param.description='${include help/params/doc/xsd/comp/doc.xsd.comp.contentElements.source.remove.xsd.anns.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.xsd.comp.contentElements.separator';
		param.title='Separator';
		param.type='boolean';
	}
	PARAM={
		param.name='show';
		param.title='Show';
		param.title.style.bold='true';
		param.description='${include help/params/show/show.htm}';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='show.icons';
		param.title='Icons';
		param.description='${include help/params/show/show.icons.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='show.linkTitle';
		param.title='Link Titles (Tooltips)';
		param.description='${include help/params/show/show.linkTitle.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='show.linkTitle.name';
		param.title='Component Name';
		param.description='${include help/params/show/show.linkTitle.name.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='show.linkTitle.namespace';
		param.title='Namespace URI';
		param.description='${include help/params/show/show.linkTitle.namespace.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='show.linkTitle.file';
		param.title='Defined in File';
		param.description='${include help/params/show/show.linkTitle.file.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='show.fileLocation';
		param.title='File Locations';
		param.description='${include help/params/show/show.fileLocation.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='show.fileLocation.relative';
		param.title='Relative Path';
		param.description='${include help/params/show/show.fileLocation.relative.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='show.fileLocation.hyperlink';
		param.title='Hyperlink';
		param.description='${include help/params/show/show.fileLocation.hyperlink.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='show.nsPrefix';
		param.title='Namespace Prefixes';
		param.description='${include help/params/show/show.nsPrefix.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='show.elementNameExt';
		param.title='Element Name Extensions';
		param.description='${include help/params/show/show.elementNameExt.htm}';
		param.type='enum';
		param.enum.values='always;repeating;never';
		param.enum.displayValues='always;for repeating names only;never';
		param.defaultValue='repeating';
	}
	PARAM={
		param.name='show.bottomText';
		param.title='Bottom Text';
		param.description='${include help/params/show/show.bottomText.htm}';
		param.type='text';
	}
	PARAM={
		param.name='show.about';
		param.title='About (footer)';
		param.description='${include help/params/show/show.about.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='proc';
		param.title='Processing';
		param.title.style.bold='true';
		param.description='${include help/params/proc/proc.htm}';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='proc.desc';
		param.title='Descriptions';
		param.title.style.bold='true';
		param.description='${include help/params/proc/proc.desc.htm}';
		param.group='true';
	}
	PARAM={
		param.name='proc.desc.xsd.annotation';
		param.title='XSD Annotations';
		param.title.style.bold='true';
		param.description='${include help/params/proc/proc.desc.xsd.annotation.htm}';
		param.group='true';
	}
	PARAM={
		param.name='proc.desc.xsd.annotation.appinfo';
		param.title='<appinfo>';
		param.title.style.bold='true';
		param.description='${include help/params/proc/proc.desc.xsd.annotation.appinfo.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
	}
	PARAM={
		param.name='proc.desc.xsd.annotation.appinfo.source';
		param.title='Source URI';
		param.description='${include help/params/proc/proc.desc.xsd.annotation.appinfo.source.htm}';
		param.type='enum';
		param.enum.values='see_link;title;xml_source;none';
		param.enum.displayValues='document as see-link;document as annotation title;include XML source;no processing';
	}
	PARAM={
		param.name='proc.desc.xsd.annotation.documentation';
		param.title='<documentation>';
		param.title.style.bold='true';
		param.description='${include help/params/proc/proc.desc.xsd.annotation.documentation.htm}';
		param.group='true';
		param.group.defaultState='expanded';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='proc.desc.xsd.annotation.documentation.lang';
		param.title='Language';
		param.description='${include help/params/proc/proc.desc.xsd.annotation.documentation.lang.htm}';
		param.group='true';
		param.group.enablingExpr='! getArrayParam("").isEmpty()';
		param.type='string';
		param.trimSpaces='true';
		param.noEmptyString='true';
		param.list='true';
		param.list.noEmptyList='true';
	}
	PARAM={
		param.name='proc.desc.xsd.annotation.documentation.lang.alt';
		param.title='Alternative Language';
		param.description='${include help/params/proc/proc.desc.xsd.annotation.documentation.lang.alt.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.noEmptyString='true';
		param.list='true';
		param.list.noEmptyList='true';
	}
	PARAM={
		param.name='proc.desc.xsd.annotation.documentation.source';
		param.title='Source URI';
		param.description='${include help/params/proc/proc.desc.xsd.annotation.documentation.source.htm}';
		param.type='enum';
		param.enum.values='see_link;title;xml_source;none';
		param.enum.displayValues='document as see-link;document as annotation title;include XML source;no processing';
	}
	PARAM={
		param.name='proc.desc.xsd.annotation.show.part.headings';
		param.title='Show part headings';
		param.description='${include help/params/proc/proc.desc.xsd.annotation.show.part.headings.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='proc.desc.xsd.annotation.show.part.headings.schemas';
		param.title='For schemas';
		param.title.style.italic='true';
		param.description='${include help/params/proc/proc.desc.xsd.annotation.show.part.headings.schemas.htm}';
		param.group='true';
	}
	PARAM={
		param.name='proc.desc.xsd.annotation.show.part.headings.schemas.include';
		param.title='Include';
		param.title.style.italic='true';
		param.description='${include help/params/proc/proc.desc.xsd.annotation.show.part.headings.schemas.include.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='proc.desc.xsd.annotation.show.part.headings.schemas.exclude';
		param.title='Exclude';
		param.title.style.italic='true';
		param.description='${include help/params/proc/proc.desc.xsd.annotation.show.part.headings.schemas.exclude.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='proc.desc.tags';
		param.title='Tags';
		param.title.style.bold='true';
		param.description='${include help/params/proc/proc.desc.tags.htm}';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='proc.desc.tags.xhtml';
		param.title='XHTML';
		param.description='${include help/params/proc/proc.desc.tags.xhtml.htm}';
		param.group='true';
		param.group.defaultState='expanded';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='proc.desc.tags.xhtml.files';
		param.title='For Files';
		param.title.style.italic='true';
		param.description='${include help/params/proc/proc.desc.tags.xhtml.files.htm}';
		param.group='true';
	}
	PARAM={
		param.name='proc.desc.tags.xhtml.files.include';
		param.title='Include';
		param.title.style.italic='true';
		param.description='${include help/params/proc/proc.desc.tags.xhtml.files.include.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='proc.desc.tags.xhtml.files.exclude';
		param.title='Exclude';
		param.title.style.italic='true';
		param.description='${include help/params/proc/proc.desc.tags.xhtml.files.exclude.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='proc.desc.tags.xhtml.images';
		param.title='Include Images';
		param.description='${include help/params/proc/proc.desc.tags.xhtml.images.htm}';
		param.group='true';
		param.group.defaultState='expanded';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='proc.desc.tags.xhtml.images.copy';
		param.title='Copy Images';
		param.description='${include help/params/proc/proc.desc.tags.xhtml.images.copy.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='proc.desc.tags.other';
		param.title='Other Tags';
		param.description='${include help/params/proc/proc.desc.tags.other.htm}';
		param.type='enum';
		param.enum.values='show;xhtml;no';
		param.enum.displayValues='show;process as XHTML;no processing';
	}
	PARAM={
		param.name='proc.desc.encode.markup.chars';
		param.title='Encode markup characters';
		param.description='${include help/params/proc/proc.desc.encode.markup.chars.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='page';
		param.title='Pagination';
		param.title.style.bold='true';
		param.description='${include help/params/page/page.htm}';
		param.group='true';
	}
	PARAM={
		param.name='page.columns';
		param.title='Generate page columns';
		param.description='${include help/params/page/page.columns.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='page.refs';
		param.title='Generate page references';
		param.description='${include help/params/page/page.refs.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='page.start';
		param.title='Start from new page';
		param.title.style.bold='true';
		param.description='${include help/params/page/page.start.htm}';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='page.start.overview';
		param.title='Overview Summary';
		param.description='${include help/params/page/page.start.overview.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='page.start.allcomps';
		param.title='All Components';
		param.description='${include help/params/page/page.start.allcomps.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='page.start.namespace';
		param.title='Namespace Details';
		param.description='${include help/params/page/page.start.namespace.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='page.start.wsdl.file';
		param.title='WSDL File Details';
		param.description='${include help/params/page/page.start.wsdl.file.htm}';
		param.group='true';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='page.start.wsdl.file.source';
		param.title='XML Source';
		param.description='${include help/params/page/page.start.wsdl.file.source.htm}';
		param.type='boolean';
		param.defaultValue.expr='! getBooleanParam("doc.wsdl.file.source.join.overview")';
	}
	PARAM={
		param.name='page.start.schema';
		param.title='Schema Details';
		param.description='${include help/params/page/page.start.schema.htm}';
		param.group='true';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='page.start.schema.source';
		param.title='XML Source';
		param.description='${include help/params/page/page.start.schema.source.htm}';
		param.type='boolean';
		param.defaultValue.expr='! getBooleanParam("doc.xsd.schema.source.join.overview")';
	}
	PARAM={
		param.name='page.start.comp';
		param.title='Component Details';
		param.description='${include help/params/page/page.start.comp.htm}';
		param.group='true';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='page.start.comp.wsdl';
		param.title='WSDL Definition';
		param.description='${include help/params/page/page.start.comp.wsdl.htm}';
		param.group='true';
	}
	PARAM={
		param.name='page.start.comp.wsdl.service';
		param.title='Service';
		param.description='${include help/params/page/page.start.comp.wsdl.service.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("page.start.comp")';
	}
	PARAM={
		param.name='page.start.comp.wsdl.binding';
		param.title='Binding';
		param.description='${include help/params/page/page.start.comp.wsdl.binding.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("page.start.comp")';
	}
	PARAM={
		param.name='page.start.comp.wsdl.portType';
		param.title='Port Type';
		param.description='${include help/params/page/page.start.comp.wsdl.portType.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("page.start.comp")';
	}
	PARAM={
		param.name='page.start.comp.wsdl.message';
		param.title='Message';
		param.description='${include help/params/page/page.start.comp.wsdl.message.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("page.start.comp")';
	}
	PARAM={
		param.name='page.start.comp.xsd';
		param.title='XSD Component';
		param.description='${include help/params/page/page.start.comp.xsd.htm}';
		param.group='true';
	}
	PARAM={
		param.name='page.start.comp.xsd.element';
		param.title='Element';
		param.description='${include help/params/page/page.start.comp.xsd.element.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("page.start.comp")';
	}
	PARAM={
		param.name='page.start.comp.xsd.complexType';
		param.title='Complex Type';
		param.description='${include help/params/page/page.start.comp.xsd.complexType.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("page.start.comp")';
	}
	PARAM={
		param.name='page.start.comp.xsd.simpleType';
		param.title='Simple Type';
		param.description='${include help/params/page/page.start.comp.xsd.simpleType.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("page.start.comp")';
	}
	PARAM={
		param.name='page.start.comp.xsd.group';
		param.title='Element Group';
		param.description='${include help/params/page/page.start.comp.xsd.group.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("page.start.comp")';
	}
	PARAM={
		param.name='page.start.comp.xsd.attribute';
		param.title='Global Attribute';
		param.description='${include help/params/page/page.start.comp.xsd.attribute.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("page.start.comp")';
	}
	PARAM={
		param.name='page.start.comp.xsd.attributeGroup';
		param.title='Attribute Group';
		param.description='${include help/params/page/page.start.comp.xsd.attributeGroup.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("page.start.comp")';
	}
	PARAM={
		param.name='page.start.xmlnsBindings';
		param.title='XML Namespace Bindings';
		param.description='${include help/params/page/page.start.xmlnsBindings.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='DiagramKit';
		param.title='DiagramKit';
		param.title.style.bold='true';
		param.description='${include help/params/DiagramKit/DiagramKit.htm}';
		param.enablingExpr='dsmType.imageProvider.name == "DiagramKit"';
		param.group='true';
		param.group.defaultState='expanded';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='dsmType.imageProvider.name == "DiagramKit"';
	}
	PARAM={
		param.name='DiagramKit.show';
		param.title='Show in Diagram';
		param.title.style.bold='true';
		param.description='${include help/params/DiagramKit/DiagramKit.show.htm}';
		param.group='true';
	}
	PARAM={
		param.name='DiagramKit.show.annotation';
		param.title='Annotations';
		param.title.style.bold='true';
		param.description='${include help/params/DiagramKit/DiagramKit.show.annotation.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='none;first_sentence;full';
		param.enum.displayValues='none;first sentence;full';
		param.defaultValue='first_sentence';
	}
	PARAM={
		param.name='DiagramKit.show.annotation.renderLineBreaks';
		param.title='Render Line Breaks';
		param.description='${include help/params/DiagramKit/DiagramKit.show.annotation.renderLineBreaks.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='DiagramKit.show.annotation.wrap';
		param.title='Wrapping';
		param.description='${include help/params/DiagramKit/DiagramKit.show.annotation.wrap.htm}';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='DiagramKit.show.annotation.wrap.optimize';
		param.title='Optimize';
		param.description='${include help/params/DiagramKit/DiagramKit.show.annotation.wrap.optimize.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='DiagramKit.show.annotation.wrap.minWidth';
		param.title='Minimal Width';
		param.description='${include help/params/DiagramKit/DiagramKit.show.annotation.wrap.minWidth.htm}';
		param.type='integer';
		param.type.units='(px)';
		param.defaultValue='120';
	}
	PARAM={
		param.name='DiagramKit.show.annotation.wrap.maxWidth';
		param.title='Maximal Width';
		param.description='${include help/params/DiagramKit/DiagramKit.show.annotation.wrap.maxWidth.htm}';
		param.enablingExpr='getBooleanParam("DiagramKit.show.annotation.wrap.optimize")';
		param.type='integer';
		param.type.units='(px)';
		param.defaultValue.expr='getIntParam("DiagramKit.layout.node.maxWidth")';
	}
	PARAM={
		param.name='DiagramKit.show.properties';
		param.title='Properties';
		param.title.style.bold='true';
		param.description='${include help/params/DiagramKit/DiagramKit.show.properties.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam()';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='DiagramKit.show.properties.element';
		param.title='Element';
		param.description='${include help/params/DiagramKit/DiagramKit.show.properties.element.htm}';
		param.group='true';
		param.group.defaultState='expanded';
		param.group.enablingExpr='getBooleanParam()';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='DiagramKit.show.properties.element.rows';
		param.title='Rows';
		param.description='${include help/params/DiagramKit/DiagramKit.show.properties.element.rows.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
		param.defaultValue='id;type;derivedBy;content;mixed;form;nillable;final;block;substGrp;substWith;enum;pattern;length;minLen/maxLen:"min/maxLen";minIncl/maxIncl:"min/maxIncl";minExcl/maxExcl:"min/maxExcl";totalDig;fracDig;whiteSp;default;fixed';
	}
	PARAM={
		param.name='DiagramKit.show.properties.attribute';
		param.title='Attibute';
		param.description='${include help/params/DiagramKit/DiagramKit.show.properties.attribute.htm}';
		param.group='true';
		param.group.defaultState='expanded';
		param.group.enablingExpr='getBooleanParam()';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='DiagramKit.show.properties.attribute.rows';
		param.title='Rows';
		param.description='${include help/params/DiagramKit/DiagramKit.show.properties.attribute.rows.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
		param.defaultValue='id;form;type;derivedBy;use;enum;pattern;length;minLen/maxLen:"min/maxLen";minIncl/maxIncl:"min/maxIncl";minExcl/maxExcl:"min/maxExcl";totalDig;fracDig;whiteSp;default;fixed';
	}
	PARAM={
		param.name='DiagramKit.show.properties.value';
		param.title='Values';
		param.description='${include help/params/DiagramKit/DiagramKit.show.properties.value.htm}';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='DiagramKit.show.properties.value.separator';
		param.title='List Separator';
		param.description='${include help/params/DiagramKit/DiagramKit.show.properties.value.separator.htm}';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='DiagramKit.show.properties.value.separator.enum';
		param.title='Enumeration';
		param.description='${include help/params/DiagramKit/DiagramKit.show.properties.value.separator.enum.htm}';
		param.type='string';
		param.defaultValue=', ';
	}
	PARAM={
		param.name='DiagramKit.show.properties.value.separator.pattern';
		param.title='Pattern';
		param.description='${include help/params/DiagramKit/DiagramKit.show.properties.value.separator.pattern.htm}';
		param.type='string';
		param.defaultValue=' ';
	}
	PARAM={
		param.name='DiagramKit.show.properties.value.equalColumnWidths';
		param.title='Equal Column Widths';
		param.description='${include help/params/DiagramKit/DiagramKit.show.properties.value.equalColumnWidths.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='DiagramKit.show.substGroup';
		param.title='Substitution Groups';
		param.description='${include help/params/DiagramKit/DiagramKit.show.substGroup.htm}';
		param.type='enum';
		param.enum.values='always;by_root_only;none';
		param.enum.displayValues='always;by diagram root only;none';
	}
	PARAM={
		param.name='DiagramKit.layout';
		param.title='Layout';
		param.title.style.bold='true';
		param.description='${include help/params/DiagramKit/DiagramKit.layout.htm}';
		param.group='true';
	}
	PARAM={
		param.name='DiagramKit.layout.node';
		param.title='Nodes';
		param.description='${include help/params/DiagramKit/DiagramKit.layout.node.htm}';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='DiagramKit.layout.node.minWidth';
		param.title='Minimal Width';
		param.description='${include help/params/DiagramKit/DiagramKit.layout.node.minWidth.htm}';
		param.type='integer';
		param.type.nonNegative='true';
		param.type.units='(px)';
		param.defaultValue='50';
	}
	PARAM={
		param.name='DiagramKit.layout.node.maxWidth';
		param.title='Maximal Width';
		param.description='${include help/params/DiagramKit/DiagramKit.layout.node.maxWidth.htm}';
		param.type='integer';
		param.type.nonNegative='true';
		param.type.units='(px)';
		param.defaultValue='350';
	}
	PARAM={
		param.name='DiagramKit.style';
		param.title='Styling';
		param.title.style.bold='true';
		param.description='${include help/params/DiagramKit/DiagramKit.style.htm}';
		param.group='true';
	}
	PARAM={
		param.name='DiagramKit.style.baseType';
		param.title='Base Type Panel';
		param.description='${include help/params/DiagramKit/DiagramKit.style.baseType.htm}';
		param.group='true';
	}
	PARAM={
		param.name='DiagramKit.style.baseType.caption.color';
		param.title='Caption Color';
		param.description='${include help/params/DiagramKit/DiagramKit.style.baseType.caption.color.htm}';
		param.type='Color';
		param.defaultValue='#6B758C';
	}
	PARAM={
		param.name='DiagramKit.style.baseType.bkgr.color';
		param.title='Background';
		param.description='${include help/params/DiagramKit/DiagramKit.style.baseType.bkgr.color.htm}';
		param.type='Color';
		param.defaultValue='#DEE7FF';
	}
	PARAM={
		param.name='DiagramKit.style.baseType.border.color';
		param.title='Border Color';
		param.description='${include help/params/DiagramKit/DiagramKit.style.baseType.border.color.htm}';
		param.type='Color';
		param.defaultValue='#808080';
	}
	PARAM={
		param.name='DiagramKit.style.annotation';
		param.title='Annotations';
		param.description='${include help/params/DiagramKit/DiagramKit.style.annotation.htm}';
		param.group='true';
	}
	PARAM={
		param.name='DiagramKit.style.annotation.color';
		param.title='Color';
		param.description='${include help/params/DiagramKit/DiagramKit.style.annotation.color.htm}';
		param.type='Color';
		param.defaultValue='#808080';
	}
</TEMPLATE_PARAMS>
<STYLES>
	TABLE_STYLE={
		style.name='About Box';
		style.id='ts1';
		style.description='Specifies border and background of "About" section added at the bottom of each generated document';
		style.css.className='aboutBox';
		table.cell.padding.both='2.5';
		table.bkgr.color='#EEEEEE';
		table.border.style='solid';
		table.border.color='#999999';
		table.border.css.render='true';
		table.page.keepTogether='true';
	}
	CHAR_STYLE={
		style.name='About Font';
		style.id='cs1';
		style.description='Specify text formatting of "About" section added at the bottom of each generated document';
		style.css.className='about';
		text.font.name='SansSerif';
		text.font.size='8.4';
	}
	HR_STYLE={
		style.name='About Separator';
		style.id='hrs1';
		style.description='Style of horizontal rule that separates "About" section';
		style.css.className='aboutRule';
		hr.lineStyle='dashed';
		hr.color='#999999';
	}
	CHAR_STYLE={
		style.name='Component List';
		style.id='cs2';
		style.description='Text formatting of various component lists, e.g.:
- Content Model Elements
- Known Direct Subtypes
etc.';
		style.css.className='compList';
		text.font.size='10';
	}
	CHAR_STYLE={
		style.name='Component List (Small)';
		style.id='cs3';
		style.description='Text formatting of component lists included in Content Element Details';
		style.css.className='compList-small';
		text.font.size='9';
	}
	PAR_STYLE={
		style.name='Component List Heading 1';
		style.id='ps1';
		style.description='Formats headings of separate component lists, e.g.: 
- Content Model Elements
- Included in content model of elements
- Known Direct Subtypes
etc.';
		style.css.className='compListHead1';
		text.font.size='10';
		text.font.style.bold='true';
		par.margin.top='10';
		par.margin.bottom='7';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Component List Heading 2';
		style.id='ps2';
		style.description='Formats headings of component lists within Known Usage Locations report, e.g.: 
- Within global complexTypes
- Within anonymous complexTypes of elements
- Within model groups
etc.';
		style.css.className='compListHead2';
		text.font.size='9';
		text.font.style.bold='true';
		par.margin.bottom='7';
		par.page.keepWithNext='true';
	}
	CHAR_STYLE={
		style.name='Default Paragraph Font';
		style.id='cs4';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Demo Excluded Message';
		style.id='cs5';
		style.css.className='demoExcl';
		text.font.style.italic='true';
		text.color.foreground='#FF0000';
	}
	CHAR_STYLE={
		style.name='Demo Excluded Message (Small)';
		style.id='cs6';
		style.css.className='demoExcl-small';
		text.font.size='9';
		text.font.style.italic='true';
		text.color.foreground='#FF0000';
	}
	CHAR_STYLE={
		style.name='Derivation Method';
		style.id='cs7';
		style.description='Formats little texts (typically, one or a few words) describing how a given XSD component was derived from others';
		style.css.className='derivMethod';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#FF9900';
	}
	PAR_STYLE={
		style.name='Derivation Tree Heading';
		style.id='ps3';
		style.description='Formats heading of Type Derivation Tree';
		style.css.className='derivTreeHead';
		text.font.size='9';
		text.font.style.bold='true';
		text.color.foreground='#990000';
		par.margin.bottom='6';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Derivation Tree Heading (Small)';
		style.id='ps4';
		style.description='Formats heading of Type Derivation Tree (smaller version).

NOTE: Type Derivation Tree may be printed in two versions: normal and smaller. The smaller version is rendered with smaller font sizes. It is used in the details of content model elements and attributes.';
		style.css.className='derivTreeHead-small';
		text.font.size='8';
		text.font.style.bold='true';
		text.color.foreground='#990000';
		par.margin.bottom='6';
		par.page.keepWithNext='true';
	}
	CHAR_STYLE={
		style.name='Derivation Tree Method';
		style.id='cs8';
		style.description='Highlights a little text (typically 1-2 words) used in Type Derivation Tree to describe how a given type is derived from its ancestor.';
		style.css.className='derivTreeMethod';
		text.font.name='Verdana';
		text.font.size='7';
		text.color.foreground='#F59200';
	}
	CHAR_STYLE={
		style.name='Derivation Tree Method (Small)';
		style.id='cs9';
		style.description='Highlights a little text (typically 1-2 words) used in the smaller version of Type Derivation Tree to describe how a given type is derived from its ancestor.

NOTE: Type Derivation Tree may be printed in two versions: normal and smaller. The smaller version is rendered with smaller font sizes. It is used in the details of content model elements and attributes.';
		style.css.className='derivTreeMethod-small';
		text.font.name='Verdana';
		text.font.size='7';
		text.color.foreground='#F59200';
	}
	CHAR_STYLE={
		style.name='Derivation Tree Type';
		style.id='cs10';
		style.description='Formats type names in Type Derivation Tree.';
		style.css.className='derivTreeType';
		text.font.name='Courier New';
		text.font.size='9';
	}
	CHAR_STYLE={
		style.name='Derivation Tree Type (Small)';
		style.id='cs11';
		style.description='Formats type names in the smaller version of Type Derivation Tree.

NOTE: Type Derivation Tree may be printed in two versions: normal and smaller. The smaller version is rendered with smaller font sizes. It is used in the details of content model elements and attributes.';
		style.css.className='derivTreeType-small';
		text.font.name='Courier New';
		text.font.size='8';
	}
	CHAR_STYLE={
		style.name='Description';
		style.id='cs12';
		style.description='The normal font for decriptions/annotations. Used for detailed descriptions of components documented globally as well as the descriptions of the whole WSDL files / XML schemas (on WSDL/schema summary page).

NOTE: Although, this style is reserved here and applied across all sub-templates, it defines no properties, thereby allowing any default font. However, you can change that.';
		style.css.className='desc';
		text.font.size='10';
	}
	CHAR_STYLE={
		style.name='Description (Small)';
		style.id='cs13';
		style.description='The smaller font for decriptions/annotations. Used in summary tables and documentation of content component (e.g. XSD content elements/attributes, WSDL ports, operations, message parts).';
		style.css.className='desc-small';
		text.font.size='9';
	}
	CHAR_STYLE={
		style.name='Description (Tiny)';
		style.id='cs14';
		style.description='The smalest font for decriptions/annotations. It is used, for instance, to format annotations of facets, which themselves are documented with a small font. Since the actual text size also depends on the font face (name), the font name in this style is fixed as \'Arial\' so as not to depend on the default browser font.';
		style.css.className='desc-tiny';
		text.font.name='SansSerif';
		text.font.size='8';
	}
	PAR_STYLE={
		style.name='Detail Heading 1';
		style.id='ps5';
		style.description='Formats headings of 1st level sections:

- Overview
- All Components
- Namespace
- WSDL File
- Schema
- Namespace Bindings

Note: These headings are used to generate 1st level items of Table Of Contents';
		style.css.className='head1';
		text.font.size='22';
		text.font.style.bold='false';
		text.color.foreground='#000000';
		par.level='1';
		par.margin.bottom='12';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Detail Heading 2';
		style.id='ps6';
		style.description='Formats headings of 2nd level sections:

- WSDL definitions details: Services, Bindings, Port Types, Messages
- XSD component details: Elements, Complex/Simple Types, Element/Attribute Groups, Global Attributes
- WSDL File Source
- Schema Source

Note: These headings are used to generate 2nd level items of Table Of Contents';
		style.css.className='head2';
		text.font.size='18';
		text.font.style.bold='true';
		text.decor.underline='false';
		text.color.foreground='#000000';
		par.level='2';
		par.alignment='Center';
		par.bkgr.opaque='true';
		par.bkgr.color='#EEEEEE';
		par.border.style='solid';
		par.border.color='#666666';
		par.margin.bottom='12';
		par.padding.left='2';
		par.padding.right='2';
		par.padding.top='2';
		par.padding.bottom='2';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Detail Heading 3';
		style.id='ps7';
		style.description='Formats headings of 3rd level sections:

- WSDL definition documentation: Service, Binding, Port Type, Message
- XSD component documentation: Element, Complex/Simple Type, Element/Attribute Group, Global Attribute

Note: These headings are used to generate 3rd level items of Table Of Contents';
		style.css.className='head3';
		text.font.size='22';
		par.level='3';
		par.margin.bottom='12';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Detail Heading 4';
		style.id='ps8';
		style.description='Formats headings of large sections of Component Documentation, e.g.:
- Description / Annotation
- XML Source
- Port Detail
- Operation Detail
- Message Part Detail
- Usage / Definition Locations
- Type (Definition) Detail
- Attribute Detail
- Content Element Detail';
		style.css.className='head4';
		text.font.size='13';
		text.font.style.bold='true';
		par.bkgr.opaque='true';
		par.bkgr.color='#EEEEEE';
		par.border.style='solid';
		par.border.color='#666666';
		par.margin.top='12';
		par.margin.bottom='8';
		par.padding.left='2';
		par.padding.right='2';
		par.padding.top='2';
		par.padding.bottom='2';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Detail Heading 4 (Level 2)';
		style.id='ps9';
		style.description='Formats headings of large sections of WSDL File / XML Schema Overviews, e.g.:

- Description / Annotation
- XML Source

Note: This style is basically the same as \'Detail Heading 4\' style, except it is used for headings that must provide 2nd level items of Table Of Contents (hence \'Paragraph | Outline Level\' property is set to \'Level 2\')

This style is used for those section, whose heading must get into Table of Contents. Otherwise, it is the same as the normal \'Detail Heading 4\' style.';
		style.css.className='head4';
		text.font.size='13';
		text.font.style.bold='true';
		par.level='2';
		par.bkgr.opaque='true';
		par.bkgr.color='#EEEEEE';
		par.border.style='solid';
		par.border.color='#666666';
		par.margin.top='12';
		par.margin.bottom='8';
		par.padding.left='2';
		par.padding.right='2';
		par.padding.top='2';
		par.padding.bottom='2';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Detail Heading 5';
		style.id='ps10';
		style.description='Formats headings of sections that describe nested or referenced components (and other minor features) within main (global) Component Documentation, e.g.:

- Port (in Service)
- Operation (in Port Type / Binding)
- Simple Content Detail (in Element / Complex Type / Simple Type / Global Atribute)';
		style.css.className='head5';
		text.font.size='11';
		text.font.style.bold='true';
		par.margin.top='10';
		par.margin.bottom='10';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Detail Heading 5 (Mono)';
		style.id='ps11';
		style.description='This style is similar to \'Detail Heading 5\' style, however it is used in cases when a monospaced font is preferable. It is applied to headings of the following sections:

- Message Part (in Message)
- Attribute (in Attribute Detail in Element / Complex Type / Attribute Group)
- Element (in Content Element Details in Element / Complex Type / Element Group)';
		style.css.className='head5-mono';
		text.font.name='Courier New';
		text.font.size='9';
		par.margin.top='10';
		par.margin.bottom='8';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Detail Heading 6';
		style.id='ps12';
		style.description='Formats headings of local documentation (that is sections that describe features of nested or referenced components within main/global Component Documentation), e.g.:

- XML Source, Operations (in Port in Service)
- XML Source, Input, Output, Fault (in Operation in Port Type / Binding)
- XML Source, Attribute Value, Type Detail (in Attribute in Attribute Detail in Element / Complex Type / Attribute Group)
- XML Source, Component Diagram, XML Representation Summary, Simple Content, Possible Children, Type Detail (in Element in Content Element Details in Element / Complex Type / Element Group).

Many of those sections replicate similar sections of global component documentation. However, the local documentation is nested in it and, therefore, everything should be smaller.';
		style.css.className='head6';
		text.font.size='10';
		text.decor.underline='true';
		par.margin.top='8';
		par.margin.bottom='6';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Detail Heading 7';
		style.id='ps13';
		style.description='Formats heading used in details of simple type derivation. That detail consists of a number of similarly organized sections nested in each other recursively (potentially at any depth). Every such a section has a heading, which is formatted with this style.';
		style.css.className='head7';
		text.font.size='8';
		text.decor.underline='true';
		par.margin.top='7';
		par.margin.bottom='2';
		par.page.keepWithNext='true';
	}
	HR_STYLE={
		style.name='Detail Separator';
		style.id='hrs2';
		style.description='Styles horizontal rules that separate various detail sections';
		style.css.className='rule';
		hr.lineStyle='none';
		hr.color='#999999';
		hr.margin.top='14';
		hr.margin.bottom='10';
	}
	PAR_STYLE={
		style.name='Detail Superheading';
		style.id='ps14';
		style.description='Formats superheading - a little text that appears above the component heading to extend it. Since the heading itself (styled with \'Detail Heading 3\') gets into the Table Of Contents, it should be as short as possible (the component name). But in the Component Documentation some additional information need to be visible that says what that component is.
For example:

SUPERHEADING: "element"
HEADING:      "ResearchReport"';
		style.css.className='superHead';
		text.font.size='14';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Diagram Heading';
		style.id='ps15';
		style.description='Heading of component diagram';
		style.css.className='diagramHead';
		text.font.style.bold='true';
		text.color.foreground='#990000';
		par.bkgr.opaque='true';
		par.bkgr.color='#F5F5F5';
		par.border.style='solid';
		par.border.color='#999999';
		par.padding.left='2.5';
		par.padding.right='2.5';
		par.padding.top='2.5';
		par.padding.bottom='2.5';
	}
	CHAR_STYLE={
		style.name='Heading Note';
		style.id='cs15';
		style.description='Formats short texts added to some headings (styled with \'Detail Heading 4\' or \'Summary Heading\') to provide more info about the whole section.

For example:

HEADING TEXT: "XML Source"
HEADING NOTE: "(w/o annotations (1); see within schema source)"

HEADING TEXT: "Attribute Detail"
HEADING NOTE: "(all declarations; defined within this component only; 1/2)"

The note text must be rendered with a flat compact font to be far less promiminent than the heading text itself. The \'bold\' property is set unselected to neutralize the \'bold\' set for the whole heading.';
		style.css.className='headNote';
		text.font.size='8.4';
		text.font.style.bold='false';
		text.decor.underline='false';
		text.color.opaque='false';
		text.border.style='none';
	}
	CHAR_STYLE={
		style.name='Heading Note (Large)';
		style.id='cs16';
		style.description='Formats short texts added to some headings styled with \'Detail Heading 2\' to provide more info about the whole section.';
		style.css.className='headNote-large';
		text.font.size='14';
		text.font.style.bold='false';
	}
	CHAR_STYLE={
		style.name='Heading Note Separator';
		style.id='cs17';
		style.description='Formats the space character that separates heading note from the main heading text.

This style is the same as \'Heading Note\' style, but in addition the \'Character spacing\' property is specified to make the separator char wider.';
		style.css.className='headNoteSp';
		text.font.size='8.4';
		text.font.style.bold='false';
		text.decor.underline='false';
		text.color.opaque='false';
		text.border.style='none';
		text.spacing.letter='3';
	}
	CHAR_STYLE={
		style.name='Heading Note Separator (Large)';
		style.id='cs18';
		style.description='Formats the space character that separates heading note from the main heading text.

This style is the same as \'Heading Note (Large)\' style, but in addition the \'Character spacing\' property is specified to make the separator char wider.';
		style.css.className='headNoteSp-large';
		text.font.size='14';
		text.font.style.bold='false';
		text.spacing.letter='4';
	}
	CHAR_STYLE={
		style.name='Hyperlink';
		style.id='cs19';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='Hyperlink (latent)';
		style.id='cs20';
		style.description='Used to format completely blended-in (latent) hyperlinks.

Certain hyperlinks must look completely the same as ordinary text and reveal themselves only when mouse cursor hovers over such a link. This is achieved by formatting the hyperlink as normal text and adding to it some extra-formatting for hovering. 

This style provides that extra formatting. It just specifies the underlining. 

The blended-in formatting itself is achieved through the ordinary text style (acting at that location), which is repeated also as a separate CSS rule for <a> tag, so that its class selector is added to the hyperlink formatting classes.';
		style.css.className='latentLink';
		text.decor.underline='true';
	}
	CHAR_STYLE={
		style.name='Mono';
		style.id='cs21';
		style.description='Sets a monospaced font.

This style is used to format component names (to make them more readable/distinguishable).';
		style.css.className='mono';
		text.font.name='Courier New';
		text.font.size='9';
	}
	CHAR_STYLE={
		style.name='Mono (Small)';
		style.id='cs22';
		style.description='Sets a monospaced font of smaller size. 

This style is used to format component names (to make them more readable/distinguishable).';
		style.css.className='mono-small';
		text.font.name='Courier New';
		text.font.size='8';
	}
	CHAR_STYLE={
		style.name='Name Extension';
		style.id='cs23';
		style.description='Formats extensions of component names.

Some XSD components may have repeating names. That is, several different components of the same type may share the same name within the same namespace. This may happen with locally defined element components and with redefinitions of complexTypes and groups. When such equally named components appear in the same documentation, they must be distinguished from each other. So, a special name extension is generated. Those name extensions may be quite long and should not overwhelm everything else (particularly in component lists). That is achieved by using small yet readable font and faded color, which are specified by this style.

NOTE: The name extension may include hyperlinks, which are formatted with the same font/color and highlighted only with underlining. So, in HTML this style may produce the same named CSS rule for both <span> element (to format text) and <a> element (to format hyperlinks, along with \'blended-in hyperlink\' style).';
		style.css.className='nameExt';
		text.font.name='Verdana';
		text.font.size='7';
		text.font.style.bold='false';
		text.color.foreground='#B2B2B2';
	}
	CHAR_STYLE={
		style.name='Name Extension Hyperlink';
		style.id='cs24';
		style.description='Styles hyperlinks from extensions of component names';
		style.css.className='nameExtLink';
		text.decor.underline='true';
	}
	PAR_STYLE={
		style.name='Normal';
		style.id='ps16';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Page Footer Font';
		style.id='cs25';
		style.description='The style for page footer text.

NOTE: Used only in RTF output.';
		text.font.name='Arial';
		text.font.style.italic='true';
	}
	CHAR_STYLE={
		style.name='Page Header Font';
		style.id='cs26';
		style.description='The style for page header text.

NOTE: Used only in RTF output.';
		text.font.name='Arial';
		text.font.style.italic='true';
	}
	CHAR_STYLE={
		style.name='Page Number';
		style.id='cs27';
		style.description='The style for page numbers (e.g. in summary tables)

NOTE: Used only in RTF output.';
		text.font.size='9';
		text.font.style.italic='true';
	}
	CHAR_STYLE={
		style.name='Page Reference';
		style.id='cs28';
		style.description='The style for cross-reference page numbers.

NOTE: Used only in RTF output.';
		text.font.name='Courier New';
		text.font.size='8';
	}
	CHAR_STYLE={
		style.name='Profile Item';
		style.id='cs29';
		style.description='Styles profile item values.

ABOUT PROFILES

Profile (in terms of this WSDL/XSD documentation) is a short summary about a particular large documented entity (e.g. WSDL file, schema, namespace) or group of entities (e.g. All Components). A profile consists of items, which include title, value and possible note (some explanation text).';
		style.css.className='profileItem';
		text.font.name='Verdana';
		text.font.size='8';
	}
	CHAR_STYLE={
		style.name='Profile Item Note';
		style.id='cs30';
		style.description='Styles extra text added to profile item value to explain its meaning, e.g.:
(blocks any substitutions of elements through substitution groups)

ABOUT PROFILES

Profile (in terms of this WSDL/XSD documentation) is a short summary about a particular large documented entity (e.g. WSDL file, schema, namespace) or group of entities (e.g. All Components). A profile consists of items, which include title and value with possible note (some explanation text).';
		text.font.name='Tahoma';
		text.font.size='8';
		text.font.style.italic='true';
	}
	PAR_STYLE={
		style.name='Profile Item Title';
		style.id='ps17';
		style.description='Styles profile item titles.

NOTE: Some of such titles can be simultaneously latent hyperlinks (which reveal themselves only when mouse cursor hovers over the heading). So, when rendered in HTML, this style may produce two named CSS rules: one for <div> element (to format the title paragraph) and other for <span> and <a> elements (to format the title text and the hyperlink). At that, in case of hyperlink, any default hyperlink formatting must be suppressed and normal title formatting preserved. That is achieved by specifically setting: no underline; black color

ABOUT PROFILES

Profile (in terms of this WSDL/XSD documentation) is a short summary about a particular large documented entity (e.g. WSDL file, schema, namespace) or group of entities (e.g. All Components). A profile consists of items, which include title and value with possible note (some explanation text).';
		style.css.className='profileItemTitle';
		text.font.size='9';
		text.font.style.bold='true';
		text.decor.underline='false';
		text.color.foreground='#000000';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Profile Item Title (Small)';
		style.id='ps18';
		style.description='Styles item titles used in embedded profiles.

For instance, when the XML schema is embedded in a WSDL file, its profile will appear inside the WSDL file profile with slightly different (smaller) item titles.';
		style.css.className='profileItemTitle-small';
		text.font.size='8';
		text.font.style.bold='true';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Property Heading';
		style.id='ps19';
		style.description='This style is used to format property title, when the title + value won\'t fit well in a single table row, that is the representation of the property value may require to occupy as much of the available document/page width as possible. In that case, the property title is printed above and the value beneath of it.

ABOUT PROPERTIES

Properties (in terms of this WSDL/XSD documentation) are short pieces of information about particular documented entities (e.g. XSD components, facets etc.) Each property has a title and value.';
		style.css.className='propHead';
		text.font.size='8';
		text.font.style.bold='true';
		par.margin.bottom='3';
		par.page.keepWithNext='true';
	}
	CHAR_STYLE={
		style.name='Property Note';
		style.id='cs31';
		style.description='Styles extra text added to property value to explain its meaning, e.g.:
"(blocks all substitutions of this element or its type)"';
		style.css.className='propNote';
		text.font.name='Tahoma';
		text.font.size='8';
		text.font.style.italic='true';
	}
	PAR_STYLE={
		style.name='Property Title';
		style.id='ps20';
		style.description='Styles property titles. Besides formatting of text, it specifies also a few paragraph settings to ensure necessary spacing between neighbouring rows and cells.

ABOUT PROPERTIES

Properties (in terms of this WSDL/XSD documentation) are short pieces of information about particular documented entities (e.g. XSD components, facets etc.) Each property has a title and value. The value may also include additional things, like:
- hyperlinks
- short explanations
- component derivation summary
- a short list of related components, schemas etc.
- a set of related properties (sub-properties)

The documented entity may have a number of different properties that need to be shown together. As properties are typically compact, they are displayed in a single table, whose left column contain property titles and right column - property values.';
		style.css.className='propTitle';
		text.font.name='SansSerif';
		text.font.size='8';
		text.font.style.bold='true';
		text.decor.underline='false';
		text.color.foreground='#000000';
		par.margin.right='6';
		par.option.nowrap='true';
	}
	CHAR_STYLE={
		style.name='Property Title Font';
		style.id='cs32';
		style.description='Specify only font (text formatting) of property title';
		style.css.className='propTitle-font';
		text.font.name='SansSerif';
		text.font.size='8';
		text.font.style.bold='true';
	}
	PAR_STYLE={
		style.name='Property Value';
		style.id='ps21';
		style.description='The base style for property values. Besides formatting of text, it specifies also a few paragraph settings to ensure necessary spacing between neighbouring rows and cells.

ABOUT PROPERTIES

Properties (in terms of this WSDL/XSD documentation) are short pieces of information about particular documented entities (e.g. XSD components, facets etc.) Each property has a title and value. The value may also include additional things, like:
- hyperlinks
- short explanations
- component derivation summary
- a short list of related components, schemas etc.
- a set of related properties (sub-properties)

The documented entity may have a number of different properties that need to be shown together. As properties are typically compact, they are displayed in a single table, whose left column contain property titles and right column - property values.';
		style.css.className='propValue';
		text.font.name='Verdana';
		text.font.size='8';
	}
	CHAR_STYLE={
		style.name='Property Value Font';
		style.id='cs33';
		style.description='Specify only font (text formatting) of property value';
		style.css.className='propValue-font';
		text.font.name='Verdana';
		text.font.size='8';
	}
	TABLE_STYLE={
		style.name='Representation Box';
		style.id='ts2';
		style.description='Specifies border and background of various representations:
- XML Representation Summary
- Simple Content Representation
- Type Derivation Tree';
		style.css.className='repBox';
		table.cell.padding.both='3';
		table.border.style='dotted';
		table.border.thickness='medium';
		table.border.color='#999999';
		table.border.css.render='true';
		table.page.keepTogether='true';
	}
	PAR_STYLE={
		style.name='Summary Heading';
		style.id='ps22';
		style.description='Styles headings of summary tables (when the heading text is placed in a one of the top table cells).';
		style.css.className='sumHead';
		text.font.size='12';
		text.font.style.bold='true';
	}
	PAR_STYLE={
		style.name='Summary Heading (Level 2)';
		style.id='ps23';
		style.description='Formats headings of summary tables.

Note: This style is basically the same as \'Summary Heading\' style, except it is used for headings that must provide 2nd level items of Table Of Contents (hence \'Paragraph | Outline Level\' property is set to \'Level 2\')';
		style.css.className='sumHead';
		text.font.size='12';
		text.font.style.bold='true';
		par.level='2';
	}
	CHAR_STYLE={
		style.name='Summary Item';
		style.id='cs34';
		style.description='Used to display component names in the left column of component summary tables. 

The font must be clear-cut (well readable) and compact (the component names are displayed unwrapped, yet some of them may be quite long strings; so, they should occupy as minimal width as possble).';
		style.css.className='sumItem';
		text.font.name='Verdana';
		text.font.size='8';
		text.font.style.bold='true';
	}
	CHAR_STYLE={
		style.name='Summary Item (Large)';
		style.id='cs35';
		style.description='Used to display names of WSDL files and XML schemas in the left column of summary tables. 

The font must be clear-cut (well readable) and compact (the file names are displayed unwrapped, yet some of them may be quite long strings; so, they should occupy as minimal width as possble).';
		style.css.className='sumItem-large';
		text.font.name='Verdana';
		text.font.size='9';
		text.font.style.bold='true';
	}
	PAR_STYLE={
		style.name='Summary Item Heading';
		style.id='ps24';
		style.description='Used to display namespace URIs in the namespace summary tables.

Since namespace URI is a long string, it cannot be displayed in the left column. So, namespace summary consists of a single column, where each namespace URI is a heading of the corresponding cell.';
		style.css.className='sumItemHead';
		text.font.name='SansSerif';
		text.font.size='9';
		text.font.style.bold='true';
		par.margin.bottom='9';
	}
	TABLE_STYLE={
		style.name='Summary Table';
		style.id='ts3';
		style.description='Styles various summary tables';
		style.css.className='sumTable';
		table.sizing='Relative';
		table.cell.padding.both='2.5';
	}
	TCELL_STYLE={
		style.name='Summary Table Cell';
		style.id='tcs1';
		style.css.className='sumTableCell';
	}
	TROW_STYLE={
		style.name='Summary Table Header';
		style.id='trs1';
		style.description='Specifies the background color of summary table header (the top table row).';
		style.css.className='sumTableHead';
		trow.bkgr.color='#EEEEEE';
		trow.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Title Heading';
		style.id='ps25';
		style.description='Styles the documentation main title';
		text.font.size='26';
		text.font.style.bold='true';
		par.alignment='Right';
		par.margin.bottom='24';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='TOC Heading';
		style.id='ps26';
		style.description='Styles the heading of Table Of Contents';
		text.font.size='22';
		text.font.style.bold='true';
		par.margin.bottom='12';
		par.page.keepWithNext='true';
	}
	CHAR_STYLE={
		style.name='XML Rep';
		style.id='cs36';
		style.description='The default font for XML Representation Summary.';
		style.css.className='xmlRep';
		text.font.name='Courier New';
		text.font.size='9';
	}
	CHAR_STYLE={
		style.name='XML Rep (Small)';
		style.id='cs37';
		style.description='The base font for XML Representation Summary (smaller version).

NOTE: XML Representation Summary may be printed in two versions: normal and smaller. The smaller version is rendered with smaller font sizes. It is used in the details of content model elements and attributes.';
		style.css.className='xmlRep-small';
		text.font.name='Courier New';
		text.font.size='8';
	}
	CHAR_STYLE={
		style.name='XML Rep Attribute Name';
		style.id='cs38';
		style.description='Formats the attribute names in XML Representation Summary.

NOTE: The attribute names may be simultaneously hyperlinks, which are formatted with the same font/color and highlighted only with underlining. So, in case of HTML, this style will produce the same named CSS rules for both <span> element (to format text) and <a> element (to format hyperlinks, along with \'blended-in hyperlink\' style).';
		style.css.className='xmlRepAttrName';
		text.font.name='Courier New';
		text.font.size='8';
		text.color.foreground='#990000';
	}
	CHAR_STYLE={
		style.name='XML Rep Attribute Name (Small)';
		style.id='cs39';
		style.description='Formats the type names in the smaller version of XML Representation Summary.

NOTE: XML Representation Summary may be printed in two versions: normal and smaller. The smaller version is rendered with smaller font sizes. It is used in the details of content model elements and attributes.';
		style.css.className='xmlRepAttrName-small';
		text.font.name='Courier New';
		text.font.size='8';
		text.color.foreground='#990000';
	}
	CHAR_STYLE={
		style.name='XML Rep Attribute Name Hyperlink';
		style.id='cs40';
		style.description='Styles hyperlinks from attribute names in XML Representation Summary';
		style.css.className='xmlRepAttrNameLink';
		text.decor.underline='true';
	}
	CHAR_STYLE={
		style.name='XML Rep Content Model';
		style.id='cs41';
		style.description='Used to format the representation of the element complex content in XML Representation Summary.';
		style.css.className='xmlRepModel';
		text.font.name='Verdana';
		text.font.size='9';
	}
	CHAR_STYLE={
		style.name='XML Rep Content Model (Small)';
		style.id='cs42';
		style.description='Used to format the representation of the element complex content in the smaller version of XML Representation Summary.

NOTE: XML Representation Summary may be printed in two versions: normal and smaller. The smaller version is rendered with smaller font sizes. It is used in the details of content model elements and attributes.';
		style.css.className='xmlRepModel-small';
		text.font.name='Verdana';
		text.font.size='8';
	}
	PAR_STYLE={
		style.name='XML Rep Heading';
		style.id='ps27';
		style.description='Heading of XML Representation Summary.';
		style.css.className='xmlRepHead';
		text.font.size='10';
		text.font.style.bold='true';
		text.color.foreground='#990000';
		par.margin.bottom='2';
	}
	PAR_STYLE={
		style.name='XML Rep Heading (Small)';
		style.id='ps28';
		style.description='Heading of XML Representation Summary (smaller version).

NOTE: XML Representation Summary may be printed in two versions: normal and smaller. The smaller version is rendered with smaller font sizes. It is used in the details of content model elements and attributes.';
		style.css.className='xmlRepHead-small';
		text.font.size='9';
		text.font.style.bold='true';
		text.color.foreground='#990000';
		par.margin.bottom='2';
	}
	CHAR_STYLE={
		style.name='XML Rep Markup';
		style.id='cs43';
		style.description='The font for XML markup characters (such as angle brackets, quotes etc.) used in XML Representation Summary.';
		style.css.className='xmlRepMarkup';
		text.font.name='Courier New';
		text.font.size='9';
		text.color.foreground='#0000FF';
		text.spacing.nbsp='true';
	}
	CHAR_STYLE={
		style.name='XML Rep Markup (Small)';
		style.id='cs44';
		style.description='The font for XML markup characters (such as angle brackets, quotes etc.) used in the smaller version of XML Representation Summary.

NOTE: XML Representation Summary may be printed in two versions: normal and smaller. The smaller version is rendered with smaller font sizes. It is used in the details of content model elements and attributes.';
		style.css.className='xmlRepMarkup-small';
		text.font.name='Courier New';
		text.font.size='8';
		text.color.foreground='#0000FF';
		text.spacing.nbsp='true';
	}
	CHAR_STYLE={
		style.name='XML Rep Name';
		style.id='cs45';
		style.description='Used in XML Representation Summary to display the name of the given element (or other component) being represented.';
		style.css.className='xmlRepName';
		text.font.name='Courier New';
		text.font.size='9';
		text.color.foreground='#990000';
	}
	CHAR_STYLE={
		style.name='XML Rep Name (Small)';
		style.id='cs46';
		style.description='Used in the smaller version of XML Representation Summary to display the name of the given element (or other component) being represented.

NOTE: XML Representation Summary may be printed in two versions: normal and smaller. The smaller version is rendered with smaller font sizes. It is used in the details of content model elements and attributes.';
		style.css.className='xmlRepName-small';
		text.font.name='Courier New';
		text.font.size='8';
		text.color.foreground='#990000';
	}
	CHAR_STYLE={
		style.name='XML Rep Value';
		style.id='cs47';
		style.description='Used in XML Representation Summary to display the values (i.e. their representations) of attributes and the element\'s simple content.';
		style.css.className='xmlRepValue';
		text.font.name='Courier New';
		text.font.size='8';
	}
	CHAR_STYLE={
		style.name='XML Rep Value (Small)';
		style.id='cs48';
		style.description='Used in the smaller version of XML Representation Summary to display the values (i.e. their representations) of attributes and the element\'s simple content.

NOTE: XML Representation Summary may be printed in two versions: normal and smaller. The smaller version is rendered with smaller font sizes. It is used in the details of content model elements and attributes.';
		style.css.className='xmlRepValue-small';
		text.font.name='Courier New';
		text.font.size='8';
	}
	CHAR_STYLE={
		style.name='XML Source';
		style.id='cs49';
		style.description='The default font for the reproduced XML source.';
		style.css.className='src';
		text.font.name='Verdana';
		text.font.size='8';
	}
	CHAR_STYLE={
		style.name='XML Source Attribute Name';
		style.id='cs50';
		style.description='The font for the names of attributes in the reproduced XML source.';
		style.css.className='srcAttrName';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#990000';
	}
	CHAR_STYLE={
		style.name='XML Source Attribute Name (Reserved)';
		style.id='cs51';
		style.description='The font for reserved attribute names in the reproduced XML source.

Reserved are namespace bindings (e.g. "xmlns:xs") and attributes from the XML namespace (e.g. "xml:lang").';
		style.css.className='srcAttrNameRes';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#FF0000';
	}
	CHAR_STYLE={
		style.name='XML Source Attribute Value';
		style.id='cs52';
		style.description='The font for the values of attributes in the reproduced XML source.

NOTE: The attribute values may be simultaneously hyperlinks, which are formatted with the same font/color and highlighted only with underlining. So, in case of HTML, this style will produce the same named CSS rule for both <span> element (to format just the value text) and <a> element (to format the hyperlink, along with \'blended-in hyperlink\' style).';
		style.css.className='srcAttrVal';
		text.font.name='Verdana';
		text.font.size='7';
		text.font.style.bold='true';
		text.color.foreground='#000000';
	}
	CHAR_STYLE={
		style.name='XML Source Attribute Value (Reserved)';
		style.id='cs53';
		style.description='The font for the values of reserved attributes in the reproduced XML source.

Reserved are namespace bindings (e.g. "xmlns:xs") and attributes from the XML namespace (e.g. "xml:lang").';
		style.css.className='srcAttrValRes';
		text.font.name='Verdana';
		text.font.size='7';
		text.font.style.bold='true';
		text.color.foreground='#FF0000';
	}
	CHAR_STYLE={
		style.name='XML Source Attribute Value Hyperlink';
		style.id='cs54';
		style.description='Styles hyperlinks from values of attributes in the reproduced XML source';
		style.css.className='srcAttrValLink';
		text.decor.underline='true';
	}
	TABLE_STYLE={
		style.name='XML Source Box';
		style.id='ts4';
		style.description='Styles border and background of reproduced XML source (when it is enclodes in a box).';
		style.css.className='srcBox';
		table.cell.padding.both='3';
		table.border.style='dotted';
		table.border.thickness='medium';
		table.border.color='#999999';
		table.border.css.render='true';
	}
	CHAR_STYLE={
		style.name='XML Source CDATA';
		style.id='cs55';
		style.description='The font for CDATA section content in the reproduced XML source';
		style.css.className='srcCDATA';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='XML Source CDATA Markup';
		style.id='cs56';
		style.description='The font for CDATA section markup ("<![CDATA[" and "]]>") in the reproduced XML source';
		style.css.className='srcCDATAMrk';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='XML Source Comment';
		style.id='cs57';
		style.description='The font for XML source comments';
		style.css.className='srcCom';
		text.font.name='Courier New';
		text.font.size='8';
		text.color.foreground='#4D4D4D';
	}
	CHAR_STYLE={
		style.name='XML Source Comment Markup';
		style.id='cs58';
		style.description='The font for XML comment markup ("<!--" and "-->") in the reproduced XML source';
		style.css.className='srcComMrk';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='XML Source DOCTYPE';
		style.id='cs59';
		style.description='The font for <!DOCTYPE> declaration (except internal subset) in the reproduced XML source';
		style.css.className='srcDOCTYPE';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='XML Source Element Name';
		style.id='cs60';
		style.description='The font for the names of elements in the reproduced XML source.';
		style.css.className='srcElemName';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#990000';
	}
	CHAR_STYLE={
		style.name='XML Source Element Value';
		style.id='cs61';
		style.description='The font for the values of elements in the reproduced XML source.';
		style.css.className='srcElemVal';
		text.font.name='Verdana';
		text.font.size='7';
		text.font.style.bold='true';
	}
	CHAR_STYLE={
		style.name='XML Source Fragment Hyperlink';
		style.id='cs62';
		style.description='This style is used to indicate a hyperlink assigned to little piece of XML source (with all markup included). That hyperlink doesn\'t reveal itself until mouse cursor hovers over it. Then, the whole text (XML source) is highlighted with the red-colored underlining, which this style defines.

That feature is used only in the XML Namespace Bindings report.';
		style.css.className='srcFrgmLink';
		text.decor.underline='true';
		text.color.foreground='#990000';
	}
	CHAR_STYLE={
		style.name='XML Source Internal Subset';
		style.id='cs63';
		style.description='The font for Internal Subset (embedded in <!DOCTYPE> declaration) in the reproduced XML source.';
		style.css.className='srclIS';
		text.font.name='Courier New';
		text.font.size='8';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='XML Source Internal Subset Markup';
		style.id='cs64';
		style.description='The font for specific XML markup surrounding Internal Subset section in the reproduced XML source';
		style.css.className='srcISMrk';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='XML Source Markup';
		style.id='cs65';
		style.description='The font for XML markup characters (such as angle brackets, quotes etc.)';
		style.css.className='srcMrk';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='XML Source Processing Instruction';
		style.id='cs66';
		style.description='The font for Processing Instructions in the reproduced XML source.

It will be used also for XML declarions (which have the same syntax as processing instructions), e.g.:
<?xml version="1.0" encoding="UTF-8"?>';
		style.css.className='srcPI';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#0000FF';
	}
</STYLES>
FMT={
	doc.lengthUnits='pt';
	doc.default.font='Times New Roman';
	doc.hlink.style.link='cs19';
}
DEMO_LIMITS={
	'wsdl-services',1;
	'wsdl-portTypes',1;
	'wsdl-bindings',1;
	'wsdl-operations',10;
	'wsdl-operation-bindings',10;
	'xsd-elements',50;
	'xsd-types',50;
	'xsd-groups',50;
	'xsd-diagrams',20;
}
<PAGE_FOOTER>
	<AREA_SEC>
		FMT={
			sec.outputStyle='table';
			text.style='cs25';
			table.sizing='Relative';
			table.cell.padding.horz='0.8';
			table.border.style='none';
			table.border.top.style='solid';
		}
		<AREA>
			<CTRL_GROUP>
				<CTRLS>
					<DATA_CTRL>
						EXPR='getStringParam("windowTitle")'
						FMT={
							ctrl.size.width='293.3';
							ctrl.size.height='39.8';
						}
					</DATA_CTRL>
					<PANEL>
						FMT={
							content.outputStyle='text-par';
							ctrl.size.width='206.3';
							ctrl.size.height='39.8';
							tcell.align.horz='Right';
							tcell.option.nowrap='true';
						}
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<TEXT_CTRL>
										TEXT='Page'
									</TEXT_CTRL>
									<DATA_CTRL>
										DOCFIELD='page'
									</DATA_CTRL>
									<TEXT_CTRL>
										TEXT='of'
									</TEXT_CTRL>
									<DATA_CTRL>
										DOCFIELD='num-pages'
									</DATA_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</PANEL>
				</CTRLS>
			</CTRL_GROUP>
		</AREA>
	</AREA_SEC>
</PAGE_FOOTER>
<ROOT>
	<TEMPLATE_CALL>
		COND='output.demoIncomplete'
		TEMPLATE_FILE='lib/demo-incomplete.tpl'
		PASSED_PARAMS={
			'$detailed','true';
		}
	</TEMPLATE_CALL>
	<AREA_SEC>
		<AREA>
			<CTRL_GROUP>
				FMT={
					par.style='ps25';
				}
				<CTRLS>
					<DATA_CTRL>
						EXPR='getParam("docTitle")'
						FMT={
							txtfl.ehtml.render='true';
						}
					</DATA_CTRL>
				</CTRLS>
			</CTRL_GROUP>
		</AREA>
	</AREA_SEC>
	<TEMPLATE_CALL>
		COND='getBooleanParam("gen.toc")
&&
output.format.supportsPagination'
		TEMPLATE_FILE='lib/TOC.tpl'
	</TEMPLATE_CALL>
	<TEMPLATE_CALL>
		COND='getBooleanParam("gen.overview")'
		TEMPLATE_FILE='lib/overview-summary.tpl'
		OUTPUT_DIR_EXPR='output.docFilesDir'
		FMT={
			sec.spacing.before='12';
		}
	</TEMPLATE_CALL>
	<TEMPLATE_CALL>
		DESCR='all component summary / detail (when grouped together)'
		COND='getBooleanParam("gen.allcomps")
||
hasParamValue("gen.grouping.comps", "allcomps")
&&
(getBooleanParam("gen.wsdl.def") || getBooleanParam("gen.xsd.comp"))'
		TEMPLATE_FILE='lib/all-components.tpl'
		OUTPUT_DIR_EXPR='getVar("nsFolder").toString()'
		FMT={
			sec.spacing.before='18';
		}
	</TEMPLATE_CALL>
	<ELEMENT_ITER>
		DESCR='ITERATE BY NAMESPACES (see "Processing | Iteration Scope" tab);
namespace URI is saved in \'nsURI\' variable (see "Processing | Init/Step/Finish | Step Expression" tab)'
		COND='getBooleanParam("gen.namespace")
||
hasParamValue("gen.grouping.comps", "namespace")
&&
(getBooleanParam("gen.wsdl.def") || getBooleanParam("gen.xsd.comp"))'
		STEP_EXPR='uri = contextElement.value.toString();
setVar("nsURI", uri);

nsFolder = makeFileName (uri);
nsFolder = (nsFolder != "") ? nsFolder : "no_namespace";
setVar("nsFolder", output.docFilesDir + "namespaces/" + nsFolder + "/");'
		TARGET_ET='#CUSTOM'
		SCOPE='custom'
		ELEMENT_ENUM_EXPR='toCustomElements (getElementMapKeys("namespaces"))'
		SORTING='by-value'
		SORTING_KEY={lpath='.',ascending}
		SORTING_COND='getBooleanParam("gen.sorting.namespaces")'
		<BODY>
			<TEMPLATE_CALL>
				DESCR='namespace overview / component detail (when grouped by namespaces)'
				TEMPLATE_FILE='lib/namespace/namespace.tpl'
				PASSED_PARAMS={
					'$nsURI','getVar("nsURI")';
				}
				OUTPUT_DIR_EXPR='getVar("nsFolder").toString()'
				PASSED_ROOT_ELEMENT_EXPR='rootElement'
				FMT={
					sec.spacing.before='18';
				}
			</TEMPLATE_CALL>
		</BODY>
	</ELEMENT_ITER>
	<ELEMENT_ITER>
		DESCR='ITERATE BY WSDL FILES'
		STEP_EXPR='wsdlFolder = makeUniquePath (
  output.docFilesDir + "wsdl",
  makeFileName (getXMLDocument().getAttrStringValue("xmlName")),
  ""
) + "/";

setServiceAttr ("wsdlFolder", wsdlFolder);
setVar("wsdlFolder", wsdlFolder);

nsURI = getAttrStringValue("targetNamespace").toString();
setVar("nsURI", nsURI);'
		TARGET_ET='wsdl:definitions'
		SCOPE='advanced-location-rules'
		RULES={
			'* -> #DOCUMENT/wsdl:definitions[checkElementsByKey("documented-wsdl-files", contextElement.id)]';
		}
		SORTING='by-expr'
		SORTING_KEY={expr='getXMLDocument().getAttrStringValue("xmlName")',ascending}
		SORTING_COND='getBooleanParam("gen.sorting.wsdl.defs")'
		<BODY>
			<TEMPLATE_CALL>
				DESCR='WSDL file overview / XML source / definition detail (when grouped by files)'
				COND='getBooleanParam("gen.wsdl.file") &&
(getBooleanParam("gen.wsdl.file.overview") || getBooleanParam("gen.wsdl.file.source"))
||
hasParamValue("gen.grouping.comps", "file") &&
getBooleanParam("gen.wsdl.def")'
				TEMPLATE_FILE='lib/wsdl/file/wsdlFile.tpl'
				OUTPUT_DIR_EXPR='getStringVar("wsdlFolder")'
				SUPPRESS_EMPTY_FILE
				FMT={
					sec.spacing.before='18';
				}
			</TEMPLATE_CALL>
			<ELEMENT_ITER>
				DESCR='iterate by embedded XML schemas'
				COND='getBooleanParam("gen.xsd.schema") &&
(hasParamValue("gen.xsd.schema.overview", "all") || hasParamValue("gen.xsd.schema.source", "all"))
||
hasParamValue("gen.grouping.comps", "file") &&
getBooleanParam("gen.xsd.comp")'
				STEP_EXPR='nsURI = getServiceAttr("targetNamespace").toString();
setVar("nsURI", nsURI);

nsFolder = makeFileName (nsURI);
nsFolder = (nsFolder != "") ? nsFolder :  "no_namespace";
setVar("nsFolder", output.docFilesDir + "namespaces/" + nsFolder + "/");

schemaFolder = getStringVar("wsdlFolder") + "types/" +
                (hasServiceAttr ("embeddedSchemaNo") ?
                  "schema" + getServiceAttr ("embeddedSchemaNo") + "/" : "");

setServiceAttr ("schemaFolder", schemaFolder);'
				TARGET_ET='xs:schema'
				SCOPE='advanced-location-rules'
				RULES={
					'* -> wsdl:types/xs:schema[checkElementsByKey ("documented-schemas", contextElement.id)]';
				}
				SORTING='by-expr'
				SORTING_KEY={expr='getXMLDocument().getAttrStringValue("xmlName")',ascending}
				SORTING_COND='getBooleanParam("gen.sorting.xsd.schemas")'
				<BODY>
					<TEMPLATE_CALL>
						DESCR='schema overview / XML source / component detail (when grouped by files)'
						TEMPLATE_FILE='lib/xsd/schema/schema.tpl'
						OUTPUT_DIR_EXPR='getServiceAttr("schemaFolder").toString()'
						FMT={
							sec.spacing.before='18';
						}
					</TEMPLATE_CALL>
				</BODY>
			</ELEMENT_ITER>
		</BODY>
	</ELEMENT_ITER>
	<ELEMENT_ITER>
		DESCR='ITERATE BY XSD FILES'
		COND='getBooleanParam("gen.xsd.schema") &&
(! hasParamValue("gen.xsd.schema.overview", "none") || ! hasParamValue("gen.xsd.schema.source", "none"))
||
hasParamValue("gen.grouping.comps", "files") &&
getBooleanParam("gen.xsd.comp")'
		STEP_EXPR='schemaFolder = makeUniquePath (
  output.docFilesDir + "schemas",
  makeFileName (getXMLDocument().getAttrStringValue("xmlName")),
  ""
) + "/";
setServiceAttr ("schemaFolder", schemaFolder);

uri = getServiceAttr("targetNamespace").toString();
setVar("nsURI", uri);

nsFolder = makeFileName (uri);
nsFolder = (nsFolder != "") ? nsFolder :  "no_namespace";
setVar("nsFolder", output.docFilesDir + "namespaces/" + nsFolder + "/");'
		TARGET_ET='xs:schema'
		SCOPE='advanced-location-rules'
		RULES={
			'* -> #DOCUMENT/xs:schema[checkElementsByKey ("documented-schemas", contextElement.id)]';
		}
		SORTING='by-expr'
		SORTING_KEY={expr='getXMLDocument().getAttrStringValue("xmlName")',ascending}
		SORTING_COND='getBooleanParam("gen.sorting.xsd.schemas")'
		<BODY>
			<TEMPLATE_CALL>
				DESCR='schema overview'
				TEMPLATE_FILE='lib/xsd/schema/schema.tpl'
				OUTPUT_DIR_EXPR='getServiceAttr("schemaFolder").toString()'
				FMT={
					sec.spacing.before='18';
				}
			</TEMPLATE_CALL>
		</BODY>
	</ELEMENT_ITER>
	<TEMPLATE_CALL>
		DESCR='namespace bindings'
		COND='getBooleanParam("gen.xmlnsBindings")'
		TEMPLATE_FILE='lib/xml/xmlns-bindings.tpl'
		OUTPUT_DIR_EXPR='output.docFilesDir'
		FMT={
			sec.spacing.before='18';
		}
	</TEMPLATE_CALL>
	<FOLDER COLLAPSED='true'>
		DESCR='Bottom Message'
		FMT={
			sec.spacing.before='12';
			sec.page.keepTogether='true';
		}
		<BODY>
			<AREA_SEC>
				DESCR='bottom text'
				COND='! getStringParam("show.bottomText").isBlank()'
				<AREA>
					<HR>
						FMT={
							hr.style='hrs2';
							hr.margin.top='0';
							hr.margin.bottom='5';
						}
					</HR>
					<CTRL_GROUP>
						<CTRLS>
							<DATA_CTRL>
								EXPR='getStringParam("show.bottomText")'
								FMT={
									txtfl.ehtml.render='true';
								}
							</DATA_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<FOLDER>
				DESCR='about FlexDoc/XML'
				COND='getBooleanParam("show.about")'
				<BODY>
					<AREA_SEC>
						<AREA>
							<HR>
								FMT={
									hr.style='hrs1';
									hr.margin.top='5';
									hr.margin.bottom='5';
									hr.page.keepWithNext='true';
								}
							</HR>
						</AREA>
					</AREA_SEC>
					<TEMPLATE_CALL>
						TEMPLATE_FILE='lib/about.tpl'
					</TEMPLATE_CALL>
				</BODY>
			</FOLDER>
		</BODY>
	</FOLDER>
</ROOT>
<STOCK_SECTIONS>
	<FOLDER>
		SS_NAME='Init'
		MATCHING_ET='#DOCUMENTS'
		NO_DIRECT_OUTPUT
		<BODY>
			<TEMPLATE_CALL>
				TEMPLATE_FILE='lib/init.tpl'
				OUTPUT_TYPE='document'
			</TEMPLATE_CALL>
			<TEMPLATE_CALL>
				DESCR='prepare diagramming engine'
				COND='dsmType.imageProvider != null
&&
getBooleanParam("DiagramKit")'
				TEMPLATE_FILE='lib/xsd/diagramming/DiagramKit.tpl'
				OUTPUT_TYPE='document'
			</TEMPLATE_CALL>
		</BODY>
	</FOLDER>
</STOCK_SECTIONS>
CHECKSUM='ihs16hcgolngC5zN7G5rtUcrs179vITZgLUB+5X5qU0'
</FLEXDOCXYZ_TEMPLATE>